/**
 * @license ngx-weui(cipchk@qq.com) v9.0.0-rc.1
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/infiniteloader', ['exports', '@angular/core', 'rxjs', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].infiniteloader = {}), global.ng.core, global.rxjs, global.ng.common));
}(this, (function (exports, core, rxjs, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: infiniteloader.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InfiniteLoaderConfig = /** @class */ (function () {
        function InfiniteLoaderConfig() {
            /**
             * 容器高度，默认：`100vh`
             */
            this.height = '100vh';
            /**
             * 滚动至x%时触发加载，默认：75%
             */
            this.percent = 75;
            /**
             * 加载中文本（支持HTML），默认：weui-loadmore 组件
             */
            this.loading = '<div class="weui-loadmore"><i class="weui-loading"></i><span class="weui-loadmore__tips">加载中…</span></div>';
            /**
             * 完成所有数据加载文本（支持HTML），默认：weui-loadmore 组件
             */
            this.finished = '<div class="weui-loadmore weui-loadmore_line"><span class="weui-loadmore__tips">已加载完毕</span></div>';
            /**
             * 滚动节流时长（单位：ms），默认：`100`
             */
            this.throttle = 100;
        }
        InfiniteLoaderConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ InfiniteLoaderConfig.ɵprov = core.ɵɵdefineInjectable({ factory: function InfiniteLoaderConfig_Factory() { return new InfiniteLoaderConfig(); }, token: InfiniteLoaderConfig, providedIn: "root" });
        return InfiniteLoaderConfig;
    }());
    if (false) {
        /**
         * 容器高度，默认：`100vh`
         * @type {?}
         */
        InfiniteLoaderConfig.prototype.height;
        /**
         * 滚动至x%时触发加载，默认：75%
         * @type {?}
         */
        InfiniteLoaderConfig.prototype.percent;
        /**
         * 加载中文本（支持HTML），默认：weui-loadmore 组件
         * @type {?}
         */
        InfiniteLoaderConfig.prototype.loading;
        /**
         * 完成所有数据加载文本（支持HTML），默认：weui-loadmore 组件
         * @type {?}
         */
        InfiniteLoaderConfig.prototype.finished;
        /**
         * 滚动节流时长（单位：ms），默认：`100`
         * @type {?}
         */
        InfiniteLoaderConfig.prototype.throttle;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: infiniteloader.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InfiniteLoaderComponent = /** @class */ (function () {
        function InfiniteLoaderComponent(el, DEF, cdr) {
            this.el = el;
            this.DEF = DEF;
            this.cdr = cdr;
            this.didScroll = false;
            this.scrollEvent = null;
            this.scrollTime = null;
            this._loading = false;
            this._finished = false;
            this._restart = false;
            this.loadmore = new core.EventEmitter();
            this.config = __assign({}, DEF);
        }
        Object.defineProperty(InfiniteLoaderComponent.prototype, "config", {
            get: /**
             * @return {?}
             */
            function () {
                return this._config;
            },
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this._config = __assign(__assign({}, this.DEF), val);
            },
            enumerable: true,
            configurable: true
        });
        /** 设置本次加载完成 */
        /**
         * 设置本次加载完成
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.resolveLoading = /**
         * 设置本次加载完成
         * @return {?}
         */
        function () {
            this._loading = false;
            this._finished = false;
            this.cdr.detectChanges();
        };
        /** 设置结束 */
        /**
         * 设置结束
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.setFinished = /**
         * 设置结束
         * @return {?}
         */
        function () {
            this._loading = false;
            this._finished = true;
            this.cdr.detectChanges();
        };
        /** 设置重新开始 */
        /**
         * 设置重新开始
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.restart = /**
         * 设置重新开始
         * @return {?}
         */
        function () {
            this._finished = false;
            this._restart = true;
            this.cdr.detectChanges();
        };
        /**
         * 触发滚动
         */
        /**
         * 触发滚动
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.scroll = /**
         * 触发滚动
         * @return {?}
         */
        function () {
            if (!this.scrollEvent || this._loading || this._finished) {
                return;
            }
            /** @type {?} */
            var target = (/** @type {?} */ (this.scrollEvent.target));
            if (this._restart) {
                target.scrollTop = 0;
                this._restart = false;
            }
            /** @type {?} */
            var scrollPercent = Math.floor(((target.scrollTop + target.clientHeight) / target.scrollHeight) * 100);
            if (scrollPercent > (/** @type {?} */ (this.config.percent))) {
                this._loading = true;
                this.loadmore.emit(this);
                this.cdr.detectChanges();
            }
        };
        /**
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.scrollTime = setInterval((/**
             * @return {?}
             */
            function () {
                if (_this.didScroll) {
                    _this.didScroll = false;
                    _this.scroll();
                }
            }), this.config.throttle);
            this.disposeScroller = rxjs.fromEvent((/** @type {?} */ (this.el.nativeElement.querySelector('.weui-infiniteloader__content'))), 'scroll').subscribe((/**
             * @param {?} $event
             * @return {?}
             */
            function ($event) {
                _this.scrollEvent = $event;
                _this.didScroll = true;
            }));
        };
        /**
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            if (this.scrollTime)
                clearTimeout(this.scrollTime);
            if (this.disposeScroller)
                this.disposeScroller.unsubscribe();
        };
        InfiniteLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-infiniteloader',
                        exportAs: 'weuiInfiniteloader',
                        template: "<div class=\"weui-infiniteloader__content\">\n  <ng-content></ng-content>\n  <div *ngIf=\"_loading || _finished\">\n    <div *ngIf=\"_loading\" [innerHTML]=\"config.loading!\"></div>\n    <div *ngIf=\"_finished\" [innerHTML]=\"config.finished!\"></div>\n  </div>\n</div>\n",
                        host: {
                            '[class.weui-infiniteloader]': 'true',
                            '[style.height]': 'config.height',
                        },
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        InfiniteLoaderComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: InfiniteLoaderConfig },
            { type: core.ChangeDetectorRef }
        ]; };
        InfiniteLoaderComponent.propDecorators = {
            config: [{ type: core.Input }],
            loadmore: [{ type: core.Output }]
        };
        return InfiniteLoaderComponent;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.didScroll;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.scrollEvent;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.scrollTime;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.disposeScroller;
        /** @type {?} */
        InfiniteLoaderComponent.prototype._loading;
        /** @type {?} */
        InfiniteLoaderComponent.prototype._finished;
        /** @type {?} */
        InfiniteLoaderComponent.prototype._restart;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype._config;
        /** @type {?} */
        InfiniteLoaderComponent.prototype.loadmore;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.el;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.DEF;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.cdr;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: infiniteloader.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InfiniteLoaderModule = /** @class */ (function () {
        function InfiniteLoaderModule() {
        }
        InfiniteLoaderModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [InfiniteLoaderComponent],
                        exports: [InfiniteLoaderComponent],
                    },] }
        ];
        return InfiniteLoaderModule;
    }());

    exports.InfiniteLoaderComponent = InfiniteLoaderComponent;
    exports.InfiniteLoaderConfig = InfiniteLoaderConfig;
    exports.InfiniteLoaderModule = InfiniteLoaderModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-infiniteloader.umd.js.map
