/**
 * @license ngx-weui(cipchk@qq.com) v9.0.0-rc.1
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/jweixin', ['exports', '@angular/core', 'ngx-weui/core'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].jweixin = {}), global.ng.core, global['ngx-weui'].core));
}(this, (function (exports, core, core$1) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: jweixin.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var JWeiXinService = /** @class */ (function () {
        function JWeiXinService(load) {
            this.load = load;
        }
        /**
         * 懒加载jweixin.js
         *
         * @param jweixinUrl 默认：//res.wx.qq.com/open/js/jweixin-1.2.0.js
         */
        /**
         * 懒加载jweixin.js
         *
         * @param {?=} jweixinUrl 默认：//res.wx.qq.com/open/js/jweixin-1.2.0.js
         * @return {?}
         */
        JWeiXinService.prototype.get = /**
         * 懒加载jweixin.js
         *
         * @param {?=} jweixinUrl 默认：//res.wx.qq.com/open/js/jweixin-1.2.0.js
         * @return {?}
         */
        function (jweixinUrl) {
            var _this = this;
            return new Promise((/**
             * @param {?} resolve
             * @return {?}
             */
            function (resolve) {
                _this.load
                    .loadScript(jweixinUrl || '//res.wx.qq.com/open/js/jweixin-1.2.0.js')
                    .then((/**
                 * @param {?} res
                 * @return {?}
                 */
                function (res) {
                    resolve(res.loaded === true);
                }))
                    .catch((/**
                 * @return {?}
                 */
                function () {
                    resolve(false);
                }));
            }));
        };
        JWeiXinService.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */
        JWeiXinService.ctorParameters = function () { return [
            { type: core$1.LoaderService }
        ]; };
        /** @nocollapse */ JWeiXinService.ɵprov = core.ɵɵdefineInjectable({ factory: function JWeiXinService_Factory() { return new JWeiXinService(core.ɵɵinject(core$1.LoaderService)); }, token: JWeiXinService, providedIn: "root" });
        return JWeiXinService;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        JWeiXinService.prototype.load;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: jweixin.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var JWeiXinModule = /** @class */ (function () {
        function JWeiXinModule() {
        }
        JWeiXinModule.decorators = [
            { type: core.NgModule, args: [{},] }
        ];
        return JWeiXinModule;
    }());

    exports.JWeiXinModule = JWeiXinModule;
    exports.JWeiXinService = JWeiXinService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-jweixin.umd.js.map
