/**
 * @license ngx-weui(cipchk@qq.com) v9.0.0-rc.1
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("@angular/core"),require("ngx-weui/core"),require("@angular/common"),require("ngx-weui/button")):"function"==typeof define&&define.amd?define("ngx-weui/pagination",["exports","@angular/core","ngx-weui/core","@angular/common","ngx-weui/button"],t):t(((e=e||self)["ngx-weui"]=e["ngx-weui"]||{},e["ngx-weui"].pagination={}),e.ng.core,e["ngx-weui"].core,e.ng.common,e["ngx-weui"].button)}(this,(function(e,t,n,i,o){"use strict";
/*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */function r(e,t,n,i){var o,r=arguments.length,a=r<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,n,i);else for(var u=e.length-1;u>=0;u--)(o=e[u])&&(a=(r<3?o(a):r>3?o(t,n,a):o(t,n))||a);return r>3&&a&&Object.defineProperty(t,n,a),a}function a(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}var u=function(){function e(){this.mode="button",this.simple=!1,this.mini=!0,this.prevText="上一页",this.nextText="下一步"}return e.decorators=[{type:t.Injectable,args:[{providedIn:"root"}]}],e.ɵprov=t.ɵɵdefineInjectable({factory:function(){return new e},token:e,providedIn:"root"}),e}();var p=function(){function e(e){this._ptArr=[],this._prevDisabled=!1,this._nextDisabled=!1,this.current=0,this.total=0,this.mini=!0,this.change=new t.EventEmitter,Object.assign(this,e)}return e.prototype.ngOnChanges=function(){"pointer"===this.mode&&(this._ptArr=Array(this.total).fill(1).map((function(e,t){return e+t}))),this._checkDisabled()},e.prototype._checkDisabled=function(){"pointer"!==this.mode&&(this._prevDisabled=this.current<=1,this._nextDisabled=this.current>=this.total)},e.prototype._goto=function(e){-1===e&&this._prevDisabled||1===e&&this._nextDisabled||(this.current+=e,this._checkDisabled(),this.change.emit(this.current))},e.decorators=[{type:t.Component,args:[{selector:"weui-pagination",exportAs:"weuiPagination",template:'<ng-template [ngIf]="mode === \'button\'">\n  <div class="weui-pagination__item weui-pagination__prev">\n    <a weui-button (click)="_goto(-1)" [weui-mini]="mini" weui-type="default" [disabled]="_prevDisabled" [innerHTML]="prevText"></a>\n  </div>\n  <div class="weui-pagination__item weui-pagination__num" *ngIf="!simple">{{ current }}/{{ total }}</div>\n  <div class="weui-pagination__item weui-pagination__next">\n    <a weui-button (click)="_goto(1)" [weui-mini]="mini" weui-type="default" [disabled]="_nextDisabled" [innerHTML]="nextText"></a>\n  </div>\n</ng-template>\n<div class="weui-pagination__item weui-pagination__num" *ngIf="mode === \'pointer\'">\n  <div *ngFor="let i of _ptArr" class="weui-pagination__dot" [class.weui-pagination__dot-active]="current === i">\n    <span></span>\n  </div>\n</div>\n',host:{class:"weui-pagination","[class.weui-pagination__non-mini]":"!mini"},preserveWhitespaces:!1,changeDetection:t.ChangeDetectionStrategy.OnPush,encapsulation:t.ViewEncapsulation.None}]}],e.ctorParameters=function(){return[{type:u}]},e.propDecorators={mode:[{type:t.Input}],current:[{type:t.Input}],total:[{type:t.Input}],simple:[{type:t.Input}],mini:[{type:t.Input}],prevText:[{type:t.Input}],nextText:[{type:t.Input}],change:[{type:t.Output}]},r([n.InputNumber(),a("design:type",Number)],e.prototype,"current",void 0),r([n.InputNumber(),a("design:type",Number)],e.prototype,"total",void 0),r([n.InputBoolean(),a("design:type",Boolean)],e.prototype,"simple",void 0),r([n.InputBoolean(),a("design:type",Boolean)],e.prototype,"mini",void 0),e}();var s=function(){function e(){}return e.decorators=[{type:t.NgModule,args:[{imports:[i.CommonModule,o.ButtonModule],declarations:[p],exports:[p]}]}],e}();e.PaginationComponent=p,e.PaginationConfig=u,e.PaginationModule=s,Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=ngx-weui-pagination.umd.min.js.map