import { EventEmitter, OnChanges, SimpleChange, SimpleChanges } from '@angular/core';
import { PickerData } from './data';
/**
 * 多列选择器组
 */
export declare class PickerGroupComponent implements OnChanges {
    /** 数据列表 */
    items: PickerData[];
    /** 当前默认位置 */
    defaultIndex: number;
    /** 多列中的位置 */
    groupIndex: number;
    /** 变更回调 */
    readonly change: EventEmitter<any>;
    private defaults;
    private startTime;
    private startY;
    private endY;
    private speed;
    _animating: boolean;
    _distance: number;
    ngOnChanges(changes: {
        [P in keyof this]?: SimpleChange;
    } & SimpleChanges): void;
    onTouchStart(e: TouchEvent): void;
    onTouchMove(e: TouchEvent): void;
    onTouchEnd(event: TouchEvent): void;
    private stop;
    private onChange;
    private _getMax;
    private _getMin;
}
