/**
 * @license ngx-weui(cipchk@qq.com) v9.0.0-rc.1
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/picker', ['exports', '@angular/core', 'ngx-weui/core', '@angular/forms', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].picker = {}), global.ng.core, global['ngx-weui'].core, global.ng.forms, global.ng.common));
}(this, (function (exports, core, core$1, forms, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: options.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function PickerOptions() { }
    if (false) {
        /**
         * 类型
         * default：无任何显示
         * form：会以表单的形式出现
         * @see https://cipchk.github.io/ngx-weui/#/example/picker
         * @type {?|undefined}
         */
        PickerOptions.prototype.type;
        /**
         * 提示分隔符信息，当type==='form'时有效
         * @type {?|undefined}
         */
        PickerOptions.prototype.separator;
        /**
         * 取消按钮文本，默认：`取消`
         * @type {?|undefined}
         */
        PickerOptions.prototype.cancel;
        /**
         * 确定按钮文本，默认：`确定`
         * @type {?|undefined}
         */
        PickerOptions.prototype.confirm;
        /**
         * 允许点击背景关闭，默认：`true`
         * @type {?|undefined}
         */
        PickerOptions.prototype.backdrop;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: data.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function PickerData() { }
    if (false) {
        /**
         * 显示文本
         * @type {?}
         */
        PickerData.prototype.label;
        /**
         * 值
         * @type {?}
         */
        PickerData.prototype.value;
        /**
         * 是否禁用
         * @type {?|undefined}
         */
        PickerData.prototype.disabled;
        /* Skipping unhandled member: [key: string]: any;*/
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: picker.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PickerConfig = /** @class */ (function () {
        function PickerConfig() {
            /**
             * 取消按钮文本，默认：`取消`
             */
            this.cancel = '取消';
            /**
             * 确定按钮文本，默认：`确定`
             */
            this.confirm = '确定';
            /**
             * 允许点击背景关闭，默认：`true`
             */
            this.backdrop = true;
        }
        PickerConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ PickerConfig.ɵprov = core.ɵɵdefineInjectable({ factory: function PickerConfig_Factory() { return new PickerConfig(); }, token: PickerConfig, providedIn: "root" });
        return PickerConfig;
    }());
    if (false) {
        /**
         * 取消按钮文本，默认：`取消`
         * @type {?}
         */
        PickerConfig.prototype.cancel;
        /**
         * 确定按钮文本，默认：`确定`
         * @type {?}
         */
        PickerConfig.prototype.confirm;
        /**
         * 允许点击背景关闭，默认：`true`
         * @type {?}
         */
        PickerConfig.prototype.backdrop;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: picker-group.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var getWindowHeight = (/**
     * @return {?}
     */
    function () {
        return window.innerHeight;
    });
    var ɵ0 = getWindowHeight;
    /**
     * 多列选择器组
     */
    var PickerGroupComponent = /** @class */ (function () {
        function PickerGroupComponent() {
            /**
             * 当前默认位置
             */
            this.defaultIndex = -1;
            /**
             * 变更回调
             */
            this.change = new core.EventEmitter();
            this.defaults = {
                offset: 2,
                // 列表初始化时的偏移量（列表初始化时，选项是聚焦在中间的，通过offset强制往上挪3项，以达到初始选项是为顶部的那项）
                rowHeight: 48,
                // 列表每一行的高度
                bodyHeight: 5 * 48,
                // picker的高度，用于辅助点击滚动的计算
                inertiaTime: 150,
                // 惯性滑动的保持时间，此值直接影响“灵敏度” (单位：ms)
                slideDuration: 300,
            };
            // 手滑动的速度 (用途：速度乘以惯性滑动的时间, 例如 300ms, 计算出应该滑动的距离)
            this._animating = false;
            this._distance = 0;
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        PickerGroupComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (changes.defaultIndex) {
                if (this.defaultIndex < 0 || (this.items && this.defaultIndex >= this.items.length)) {
                    this.defaultIndex = 0;
                }
                this._distance = (this.defaults.offset - this.defaultIndex) * this.defaults.rowHeight;
            }
        };
        /**
         * @param {?} e
         * @return {?}
         */
        PickerGroupComponent.prototype.onTouchStart = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (this.items.length <= 1)
                return;
            this.startY = e.changedTouches[0].pageY;
            this.startTime = +new Date();
        };
        /**
         * @param {?} e
         * @return {?}
         */
        PickerGroupComponent.prototype.onTouchMove = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (this.items.length <= 1)
                return;
            /** @type {?} */
            var endTime = +new Date();
            this.endY = e.changedTouches[0].pageY;
            // 计算滑动的速度: 距离 / 时间
            /** @type {?} */
            var _distance = this.endY - this.startY;
            this.speed = _distance / (endTime - this.startTime);
            // 重新设置开始时间、开始位置
            this.startTime = endTime;
            this.startY = this.endY;
            this._animating = false; // ms
            this._distance += _distance; // 内容移动的距离
            e.preventDefault();
        };
        /**
         * @param {?} event
         * @return {?}
         */
        PickerGroupComponent.prototype.onTouchEnd = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (!this.startY)
                return;
            this.endY = event.changedTouches[0].pageY;
            /**
             * 思路:
             * 根据最后一次touchmove事件的速度(speed)，判断是否执行惯性滑动；
             * 如果speed大于1、小于5，则根据速度乘以惯性滑动的时间(如150ms)，计算出应该滑动的距离；
             * 如果speed大于5，则按照屏幕的高度(减去列表高度的一半)，作为该滑动的距离。
             * @type {?}
             */
            var _speed = Math.abs(this.speed);
            if (_speed >= 5) {
                /** @type {?} */
                var windowY = getWindowHeight() - this.defaults.bodyHeight / 2;
                this.stop(windowY - this.endY);
            }
            else if (_speed >= 1) {
                /** @type {?} */
                var diff = this.speed * this.defaults.inertiaTime;
                this.stop(diff);
            }
            else {
                this.stop(0);
            }
            this.startY = 0;
        };
        /**
         * @private
         * @param {?} diff
         * @return {?}
         */
        PickerGroupComponent.prototype.stop = /**
         * @private
         * @param {?} diff
         * @return {?}
         */
        function (diff) {
            /** @type {?} */
            var dist = this._distance + diff;
            /** @type {?} */
            var defaults = this.defaults;
            // 移动到最接近的那一行
            dist = Math.round(dist / defaults.rowHeight) * defaults.rowHeight;
            /** @type {?} */
            var max = this._getMax(defaults.offset, defaults.rowHeight);
            /** @type {?} */
            var min = this._getMin(defaults.offset, defaults.rowHeight, this.items.length);
            // 不要超过最大值或者最小值
            dist = Math.max(Math.min(dist, max), min);
            // 如果是 disabled 的就跳过
            /** @type {?} */
            var index = defaults.offset - dist / defaults.rowHeight;
            while (!!this.items[index] && this.items[index].disabled) {
                diff > 0 ? ++index : --index;
            }
            dist = (defaults.offset - index) * defaults.rowHeight;
            this._animating = true;
            this._distance = dist; // px
            // 触发选择事件
            this.onChange(this.items[index], index);
        };
        /**
         * @private
         * @param {?} item
         * @param {?=} index
         * @return {?}
         */
        PickerGroupComponent.prototype.onChange = /**
         * @private
         * @param {?} item
         * @param {?=} index
         * @return {?}
         */
        function (item, index) {
            if (index === void 0) { index = 0; }
            this.change.emit({ item: item, index: index });
        };
        /**
         * @private
         * @param {?} offset
         * @param {?} rowHeight
         * @return {?}
         */
        PickerGroupComponent.prototype._getMax = /**
         * @private
         * @param {?} offset
         * @param {?} rowHeight
         * @return {?}
         */
        function (offset, rowHeight) {
            return offset * rowHeight;
        };
        /**
         * @private
         * @param {?} offset
         * @param {?} rowHeight
         * @param {?} length
         * @return {?}
         */
        PickerGroupComponent.prototype._getMin = /**
         * @private
         * @param {?} offset
         * @param {?} rowHeight
         * @param {?} length
         * @return {?}
         */
        function (offset, rowHeight, length) {
            return -(rowHeight * (length - offset - 1));
        };
        PickerGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-picker-group',
                        exportAs: 'weuiPickerGroup',
                        template: "<ng-content></ng-content>\n<div class=\"weui-picker__mask\"></div>\n<div class=\"weui-picker__indicator\"></div>\n<div\n  class=\"weui-picker__content\"\n  [ngStyle]=\"{\n    transform: 'translate3d(0,' + _distance + 'px, 0px)',\n    transition: _animating ? 'all 0.3s ease 0s' : 'none'\n  }\"\n>\n  <div class=\"weui-picker__item\" *ngFor=\"let item of items\" [ngClass]=\"{ 'weui-picker__item_disabled': item.disabled }\">\n    {{ item.label || item.value }}\n  </div>\n</div>\n",
                        host: {
                            '(touchstart)': 'onTouchStart($event)',
                            '(touchmove)': 'onTouchMove($event)',
                            '(touchend)': 'onTouchEnd($event)',
                            '[class.weui-picker__group]': 'true',
                        },
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        PickerGroupComponent.propDecorators = {
            items: [{ type: core.Input }],
            defaultIndex: [{ type: core.Input }],
            groupIndex: [{ type: core.Input }],
            change: [{ type: core.Output }]
        };
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number)
        ], PickerGroupComponent.prototype, "defaultIndex", void 0);
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number)
        ], PickerGroupComponent.prototype, "groupIndex", void 0);
        return PickerGroupComponent;
    }());
    if (false) {
        /**
         * 数据列表
         * @type {?}
         */
        PickerGroupComponent.prototype.items;
        /**
         * 当前默认位置
         * @type {?}
         */
        PickerGroupComponent.prototype.defaultIndex;
        /**
         * 多列中的位置
         * @type {?}
         */
        PickerGroupComponent.prototype.groupIndex;
        /**
         * 变更回调
         * @type {?}
         */
        PickerGroupComponent.prototype.change;
        /**
         * @type {?}
         * @private
         */
        PickerGroupComponent.prototype.defaults;
        /**
         * @type {?}
         * @private
         */
        PickerGroupComponent.prototype.startTime;
        /**
         * @type {?}
         * @private
         */
        PickerGroupComponent.prototype.startY;
        /**
         * @type {?}
         * @private
         */
        PickerGroupComponent.prototype.endY;
        /**
         * @type {?}
         * @private
         */
        PickerGroupComponent.prototype.speed;
        /** @type {?} */
        PickerGroupComponent.prototype._animating;
        /** @type {?} */
        PickerGroupComponent.prototype._distance;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: picker.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PickerComponent = /** @class */ (function () {
        function PickerComponent(DEF) {
            this.DEF = DEF;
            this.onChange = Function.prototype;
            this.onTouched = Function.prototype;
            this._showP = false;
            this._shown = false;
            this._text = '';
            this.disabled = false;
            /**
             * 确认后回调当前选择数据（包括已选面板所有数据）
             *
             * `{ value: '10000', items: [ {}, {}, {} ] }`
             */
            this.change = new core.EventEmitter();
            /**
             * 列变更时回调
             */
            this.groupChange = new core.EventEmitter();
            /**
             * 取消后回调
             */
            this.cancel = new core.EventEmitter();
            /**
             * 显示时回调
             */
            this.show = new core.EventEmitter();
            /**
             * 隐藏后回调
             */
            this.hide = new core.EventEmitter();
        }
        Object.defineProperty(PickerComponent.prototype, "defaultSelect", {
            /**
             * 当前默认位置，数组的长度必须等同于 groups 长度
             */
            set: /**
             * 当前默认位置，数组的长度必须等同于 groups 长度
             * @param {?} d
             * @return {?}
             */
            function (d) {
                if (d)
                    this._selected = d;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PickerComponent.prototype, "groups", {
            /**
             * 多列数据，以数组的长度来决定几列数据
             * 支持string[]单列数组，单纯只是为了方便
             */
            set: /**
             * 多列数据，以数组的长度来决定几列数据
             * 支持string[]单列数组，单纯只是为了方便
             * @param {?} d
             * @return {?}
             */
            function (d) {
                if (!d)
                    throw new Error('无效数据源');
                if (d.length > 0) {
                    if (typeof d[0] === 'string') {
                        d = [
                            ((/** @type {?} */ (d))).map((/**
                             * @param {?} v
                             * @return {?}
                             */
                            function (v) {
                                return { label: v, value: v };
                            })),
                        ];
                    }
                }
                this._groups = (/** @type {?} */ (d));
                this._selected = this._selected ? this._selected : Array(d.length).fill(0);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        PickerComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (!this.options)
                this.parseOptions();
        };
        /**
         * @param {?} fh
         * @return {?}
         */
        PickerComponent.prototype._onHide = /**
         * @param {?} fh
         * @return {?}
         */
        function (fh) {
            var _this = this;
            if (!fh && !this.options.backdrop)
                return false;
            this._shown = false;
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this._showP = false;
                _this.hide.emit();
            }), 300);
            return this;
        };
        /**
         * @return {?}
         */
        PickerComponent.prototype._onShow = /**
         * @return {?}
         */
        function () {
            if (this.disabled)
                return false;
            this._showP = true;
            this._shown = true;
            this.show.emit();
            return this;
        };
        /**
         * @private
         * @return {?}
         */
        PickerComponent.prototype.parseOptions = /**
         * @private
         * @return {?}
         */
        function () {
            this.options = (/** @type {?} */ (__assign(__assign({ type: 'form', cancel: '取消', confirm: '确定', backdrop: true, gruopCount: null, separator: ' ' }, this.DEF), this.options)));
        };
        /**
         * @private
         * @return {?}
         */
        PickerComponent.prototype.getSelecteItem = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var res = [];
            this._groups.forEach((/**
             * @param {?} items
             * @param {?} idx
             * @return {?}
             */
            function (items, idx) {
                /** @type {?} */
                var item = items[_this._selected[idx]];
                if (item)
                    res.push(item);
            }));
            return res;
        };
        /**
         * @template THIS
         * @this {THIS}
         * @param {?=} res
         * @return {THIS}
         */
        PickerComponent.prototype._setText = /**
         * @template THIS
         * @this {THIS}
         * @param {?=} res
         * @return {THIS}
         */
        function (res) {
            if (res === void 0) { res = null; }
            if (res == null)
                res = (/** @type {?} */ (this)).getSelecteItem();
            if (res.length > 0)
                (/** @type {?} */ (this))._text = res.map((/**
                 * @param {?} i
                 * @return {?}
                 */
                function (i) { return i.label || i.value; })).join((/** @type {?} */ (this)).options.separator);
            return (/** @type {?} */ (this));
        };
        // 根据_value解析成相应值位置
        // 根据_value解析成相应值位置
        /**
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        PickerComponent.prototype._setDefault = 
        // 根据_value解析成相应值位置
        /**
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        function () {
            var _this = this;
            (/** @type {?} */ (this))._selected = [];
            (/** @type {?} */ (this))._groups.forEach((/**
             * @param {?} items
             * @return {?}
             */
            function (items) {
                /** @type {?} */
                var idx = items.findIndex((/**
                 * @param {?} i
                 * @return {?}
                 */
                function (i) { return i.value === (/** @type {?} */ (_this))._value; }));
                if (idx <= -1)
                    idx = 0;
                (/** @type {?} */ (_this))._selected.push(idx);
            }));
            return (/** @type {?} */ (this));
        };
        /**
         * @param {?} data
         * @param {?} groupIndex
         * @return {?}
         */
        PickerComponent.prototype._onGroupChange = /**
         * @param {?} data
         * @param {?} groupIndex
         * @return {?}
         */
        function (data, groupIndex) {
            this._selected[groupIndex] = data.index;
            this.groupChange.emit({ item: data.item, index: data.index, groupIndex: groupIndex });
        };
        /**
         * @return {?}
         */
        PickerComponent.prototype._onCancel = /**
         * @return {?}
         */
        function () {
            this.cancel.emit();
            this._onHide(true);
            return false;
        };
        /**
         * @return {?}
         */
        PickerComponent.prototype._onConfirm = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var res = this.getSelecteItem();
            this._setText(res);
            /** @type {?} */
            var lastItem = res[res.length - 1] || {};
            /** @type {?} */
            var val = lastItem.value || lastItem.label;
            this.onChange(val);
            this.onTouched();
            this.change.emit({ value: val, items: res });
            this._onHide(true);
            return false;
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        PickerComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (changes.options) {
                this.parseOptions();
            }
        };
        /**
         * @param {?} value
         * @return {?}
         */
        PickerComponent.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (!value)
                this._text = '';
            if (value && value !== this._value) {
                this._value = value;
                // todo：当ngModel传递一个未列表中的值的情况 & 多列时数据对应问题
                this._setDefault()._setText();
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        PickerComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        PickerComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        PickerComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.disabled = isDisabled;
        };
        /**
         * @param {?} ev
         * @return {?}
         */
        PickerComponent.prototype._onFocus = /**
         * @param {?} ev
         * @return {?}
         */
        function (ev) {
            ((/** @type {?} */ ((/** @type {?} */ (ev.target))))).blur();
        };
        PickerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-picker',
                        exportAs: 'weuiPicker',
                        template: "<input\n  type=\"text\"\n  class=\"weui-input\"\n  value=\"{{ _text }}\"\n  placeholder=\"{{ placeholder }}\"\n  readonly=\"readonly\"\n  (focus)=\"_onFocus($event)\"\n  (click)=\"_onShow()\"\n  [disabled]=\"disabled\"\n  *ngIf=\"options.type === 'form'\"\n/>\n<div [hidden]=\"!_showP\">\n  <div class=\"weui-mask\" (click)=\"_onHide(false)\" [ngClass]=\"{ 'weui-animate-fade-in': _shown, 'weui-animate-fade-out': !_shown }\"></div>\n  <div class=\"weui-half-screen-dialog weui-picker\" [ngClass]=\"{ 'weui-animate-slide-up': _shown, 'weui-animate-slide-down': !_shown }\">\n    <div class=\"weui-half-screen-dialog__hd\">\n      <div class=\"weui-half-screen-dialog__hd__side\">\n        <button (click)=\"_onCancel()\" class=\"weui-icon-btn weui-icon-btn_close weui-picker__btn\">{{ options.cancel }}</button>\n      </div>\n      <div *ngIf=\"title\" class=\"weui-half-screen-dialog__hd__main\">\n        <strong class=\"weui-half-screen-dialog__title\">{{ title }}</strong>\n      </div>\n    </div>\n    <div class=\"weui-half-screen-dialog__bd\">\n      <div class=\"weui-picker__bd\">\n        <weui-picker-group\n          tappable\n          *ngFor=\"let items of _groups; let i = index\"\n          [items]=\"items\"\n          [defaultIndex]=\"_selected[i]\"\n          [groupIndex]=\"i\"\n          (change)=\"_onGroupChange($event, i)\"\n        ></weui-picker-group>\n      </div>\n    </div>\n    <div class=\"weui-half-screen-dialog__ft\">\n      <a class=\"weui-btn weui-btn_primary weui-picker__btn\" (click)=\"_onConfirm()\">{{ options.confirm }}</a>\n    </div>\n  </div>\n</div>\n",
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return PickerComponent; })),
                                multi: true,
                            },
                        ],
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        PickerComponent.ctorParameters = function () { return [
            { type: PickerConfig }
        ]; };
        PickerComponent.propDecorators = {
            options: [{ type: core.Input }],
            defaultSelect: [{ type: core.Input }],
            groups: [{ type: core.Input }],
            placeholder: [{ type: core.Input }],
            title: [{ type: core.Input }],
            disabled: [{ type: core.Input }],
            change: [{ type: core.Output }],
            groupChange: [{ type: core.Output }],
            cancel: [{ type: core.Output }],
            show: [{ type: core.Output }],
            hide: [{ type: core.Output }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], PickerComponent.prototype, "disabled", void 0);
        return PickerComponent;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        PickerComponent.prototype.onChange;
        /**
         * @type {?}
         * @private
         */
        PickerComponent.prototype.onTouched;
        /** @type {?} */
        PickerComponent.prototype._showP;
        /** @type {?} */
        PickerComponent.prototype._shown;
        /**
         * 配置项
         * @type {?}
         */
        PickerComponent.prototype.options;
        /** @type {?} */
        PickerComponent.prototype._value;
        /** @type {?} */
        PickerComponent.prototype._selected;
        /** @type {?} */
        PickerComponent.prototype._groups;
        /** @type {?} */
        PickerComponent.prototype._text;
        /**
         * 当 `options.type==='form'` 时，占位符文本
         * @type {?}
         */
        PickerComponent.prototype.placeholder;
        /** @type {?} */
        PickerComponent.prototype.title;
        /** @type {?} */
        PickerComponent.prototype.disabled;
        /**
         * 确认后回调当前选择数据（包括已选面板所有数据）
         *
         * `{ value: '10000', items: [ {}, {}, {} ] }`
         * @type {?}
         */
        PickerComponent.prototype.change;
        /**
         * 列变更时回调
         * @type {?}
         */
        PickerComponent.prototype.groupChange;
        /**
         * 取消后回调
         * @type {?}
         */
        PickerComponent.prototype.cancel;
        /**
         * 显示时回调
         * @type {?}
         */
        PickerComponent.prototype.show;
        /**
         * 隐藏后回调
         * @type {?}
         */
        PickerComponent.prototype.hide;
        /**
         * @type {?}
         * @private
         */
        PickerComponent.prototype.DEF;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: picker-city.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 城市选择器（并不包含城市数据，可以参考示例中的数据格式）
     */
    var CityPickerComponent = /** @class */ (function () {
        function CityPickerComponent() {
            this.onChange = Function.prototype;
            this.onTouched = Function.prototype;
            this._groups = [];
            this._selected = [];
            this.dataMap = {
                label: 'name',
                value: 'code',
                items: 'sub',
            };
            /**
             * 确认后回调当前选择数据（包括已选面板所有数据）
             *
             * `{ value: '10000', items: [ {}, {}, {} ] }`
             */
            this.change = new core.EventEmitter();
            /**
             * 列变更时回调
             */
            this.groupChange = new core.EventEmitter();
            /**
             * 取消后回调
             */
            this.cancel = new core.EventEmitter();
            /**
             * 显示时回调
             */
            this.show = new core.EventEmitter();
            /**
             * 隐藏后回调
             */
            this.hide = new core.EventEmitter();
        }
        Object.defineProperty(CityPickerComponent.prototype, "data", {
            /** 城市数据，可以参考示例中的数据格式 */
            set: /**
             * 城市数据，可以参考示例中的数据格式
             * @param {?} d
             * @return {?}
             */
            function (d) {
                this._tmpData = d;
                this.parseData(this._tmpData, this.dataMap.items, this._selected);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        CityPickerComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this._tmpData = null;
            this._groups = null;
        };
        /**
         * @private
         * @param {?} data
         * @param {?} subKey
         * @param {?=} selected
         * @param {?=} group
         * @param {?=} newselected
         * @return {?}
         */
        CityPickerComponent.prototype.parseData = /**
         * @private
         * @param {?} data
         * @param {?} subKey
         * @param {?=} selected
         * @param {?=} group
         * @param {?=} newselected
         * @return {?}
         */
        function (data, subKey, selected, group, newselected) {
            var _this = this;
            if (selected === void 0) { selected = []; }
            if (group === void 0) { group = []; }
            if (newselected === void 0) { newselected = []; }
            /** @type {?} */
            var _selected = 0;
            if (Array.isArray(selected) && selected.length > 0) {
                /** @type {?} */
                var _selectedClone = selected.slice(0);
                _selected = _selectedClone.shift();
                selected = _selectedClone;
            }
            if (typeof data[_selected] === 'undefined') {
                _selected = 0;
            }
            newselected.push(_selected);
            /** @type {?} */
            var item = data[_selected];
            /** @type {?} */
            var _group = JSON.parse(JSON.stringify(data));
            _group.forEach((/**
             * @param {?} g
             * @return {?}
             */
            function (g) {
                delete g[subKey];
                g.label = g[_this.dataMap.label];
                g.value = g[_this.dataMap.value];
            }));
            group.push(_group);
            if (typeof item[subKey] !== 'undefined' && Array.isArray(item[subKey])) {
                return this.parseData(item[subKey], subKey, selected, group, newselected);
            }
            else {
                this._groups = group;
                this._selected = newselected;
                return { groups: group, newselected: newselected };
            }
        };
        /**
         * 将值转换成位置
         */
        /**
         * 将值转换成位置
         * @private
         * @param {?} data
         * @param {?} subKey
         * @param {?=} dept
         * @param {?=} newSelected
         * @return {?}
         */
        CityPickerComponent.prototype.valueToSelect = /**
         * 将值转换成位置
         * @private
         * @param {?} data
         * @param {?} subKey
         * @param {?=} dept
         * @param {?=} newSelected
         * @return {?}
         */
        function (data, subKey, dept, newSelected) {
            var _this = this;
            if (dept === void 0) { dept = 1; }
            if (newSelected === void 0) { newSelected = []; }
            /** @type {?} */
            var code = (this._value.substr(0, dept * 2) + '0000').substr(0, 6);
            /** @type {?} */
            var _selected = data.findIndex((/**
             * @param {?} w
             * @return {?}
             */
            function (w) { return w[_this.dataMap.value] === code; }));
            if (_selected <= -1) {
                _selected = 0;
            }
            newSelected.push(_selected);
            /** @type {?} */
            var item = data[_selected];
            if (typeof item[subKey] !== 'undefined' && Array.isArray(item[subKey])) {
                return this.valueToSelect(item[subKey], subKey, ++dept, newSelected);
            }
            else {
                this._selected = newSelected;
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    _this._pickerInstance._setText();
                }), 100);
                return newSelected;
            }
        };
        /**
         * @param {?} data
         * @return {?}
         */
        CityPickerComponent.prototype._onCityChange = /**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            this.onChange(data.value);
            this.onTouched();
            this.change.emit(data);
        };
        /**
         * @param {?} res
         * @return {?}
         */
        CityPickerComponent.prototype._onCityGroupChange = /**
         * @param {?} res
         * @return {?}
         */
        function (res) {
            this._selected[res.groupIndex] = res.index;
            if (res.groupIndex !== 2)
                this.parseData(this._tmpData, this.dataMap.items, this._selected);
            this.groupChange.emit(res);
        };
        /**
         * @return {?}
         */
        CityPickerComponent.prototype._onCityCancelChange = /**
         * @return {?}
         */
        function () {
            this.cancel.emit();
        };
        /** 服务于Service，并无实际意义 */
        /**
         * 服务于Service，并无实际意义
         * @return {?}
         */
        CityPickerComponent.prototype._triggerShow = /**
         * 服务于Service，并无实际意义
         * @return {?}
         */
        function () {
            this._pickerInstance._onShow();
        };
        /**
         * @return {?}
         */
        CityPickerComponent.prototype._onShow = /**
         * @return {?}
         */
        function () {
            this.show.emit();
        };
        /**
         * @return {?}
         */
        CityPickerComponent.prototype._onHide = /**
         * @return {?}
         */
        function () {
            this.hide.emit();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        CityPickerComponent.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (!value) {
                this._pickerInstance._text = '';
                return;
            }
            this._value = value;
            if (this._value && this._value.length === 6) {
                this.valueToSelect(this._tmpData, this.dataMap.items, 1);
                this.parseData(this._tmpData, this.dataMap.items, this._selected);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        CityPickerComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        CityPickerComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        CityPickerComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.disabled = isDisabled;
        };
        CityPickerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-city-picker',
                        exportAs: 'weuiCityPicker',
                        template: "\n    <weui-picker\n      [placeholder]=\"placeholder\"\n      [groups]=\"_groups!\"\n      [defaultSelect]=\"_selected\"\n      [disabled]=\"disabled\"\n      [title]=\"title\"\n      [options]=\"options\"\n      (show)=\"_onShow()\"\n      (hide)=\"_onHide()\"\n      (change)=\"_onCityChange($event)\"\n      (groupChange)=\"_onCityGroupChange($event)\"\n      (cancel)=\"_onCityCancelChange()\"\n    ></weui-picker>\n  ",
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return CityPickerComponent; })),
                                multi: true,
                            },
                        ],
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        CityPickerComponent.propDecorators = {
            data: [{ type: core.Input }],
            _pickerInstance: [{ type: core.ViewChild, args: [PickerComponent, { static: true },] }],
            dataMap: [{ type: core.Input }],
            options: [{ type: core.Input }],
            placeholder: [{ type: core.Input }],
            title: [{ type: core.Input }],
            disabled: [{ type: core.Input }],
            change: [{ type: core.Output }],
            groupChange: [{ type: core.Output }],
            cancel: [{ type: core.Output }],
            show: [{ type: core.Output }],
            hide: [{ type: core.Output }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], CityPickerComponent.prototype, "disabled", void 0);
        return CityPickerComponent;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        CityPickerComponent.prototype._tmpData;
        /**
         * @type {?}
         * @private
         */
        CityPickerComponent.prototype.onChange;
        /**
         * @type {?}
         * @private
         */
        CityPickerComponent.prototype.onTouched;
        /** @type {?} */
        CityPickerComponent.prototype._value;
        /** @type {?} */
        CityPickerComponent.prototype._groups;
        /** @type {?} */
        CityPickerComponent.prototype._selected;
        /** @type {?} */
        CityPickerComponent.prototype._pickerInstance;
        /** @type {?} */
        CityPickerComponent.prototype.dataMap;
        /**
         * 配置项
         * @type {?}
         */
        CityPickerComponent.prototype.options;
        /**
         * 当options.type=='form'时，占位符文本
         * @type {?}
         */
        CityPickerComponent.prototype.placeholder;
        /** @type {?} */
        CityPickerComponent.prototype.title;
        /** @type {?} */
        CityPickerComponent.prototype.disabled;
        /**
         * 确认后回调当前选择数据（包括已选面板所有数据）
         *
         * `{ value: '10000', items: [ {}, {}, {} ] }`
         * @type {?}
         */
        CityPickerComponent.prototype.change;
        /**
         * 列变更时回调
         * @type {?}
         */
        CityPickerComponent.prototype.groupChange;
        /**
         * 取消后回调
         * @type {?}
         */
        CityPickerComponent.prototype.cancel;
        /**
         * 显示时回调
         * @type {?}
         */
        CityPickerComponent.prototype.show;
        /**
         * 隐藏后回调
         * @type {?}
         */
        CityPickerComponent.prototype.hide;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: picker-date.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var FORMAT = {
        format: null,
        yu: '年',
        Mu: '月',
        du: '日',
        hu: '时',
        mu: '分',
    };
    /**
     * 日期时间选择器
     */
    var DatePickerComponent = /** @class */ (function () {
        function DatePickerComponent(datePipe) {
            this.datePipe = datePipe;
            this.initFlag = false;
            this.onChange = Function.prototype;
            this.onTouched = Function.prototype;
            this._groups = [];
            this._selected = [];
            /**
             * 类型
             * + `date-ym` 年月
             * + `date` 日期
             * + `datetime` 日期&时间（不包括秒）
             * + `time` 时间（不包括秒）
             */
            this.type = 'date';
            this._format = __assign({}, FORMAT);
            /**
             * 确认后回调
             */
            this.change = new core.EventEmitter();
            /**
             * 列变更时回调
             */
            this.groupChange = new core.EventEmitter();
            /**
             * 取消后回调
             */
            this.cancel = new core.EventEmitter();
            /**
             * 显示时回调
             */
            this.show = new core.EventEmitter();
            /**
             * 隐藏后回调
             */
            this.hide = new core.EventEmitter();
        }
        Object.defineProperty(DatePickerComponent.prototype, "format", {
            /**
             * 日期格式化代码，实际是采用 DatePipe，所有代码内容和它一样
             */
            set: /**
             * 日期格式化代码，实际是采用 DatePipe，所有代码内容和它一样
             * @param {?} v
             * @return {?}
             */
            function (v) {
                if (typeof v === 'string') {
                    this._format = __assign(__assign({}, FORMAT), { format: v });
                }
                else {
                    this._format = __assign(__assign({}, FORMAT), v);
                }
            },
            enumerable: true,
            configurable: true
        });
        // todo: 太粗暴，需要优化代码
        // todo: 太粗暴，需要优化代码
        /**
         * @private
         * @return {?}
         */
        DatePickerComponent.prototype.genGroups = 
        // todo: 太粗暴，需要优化代码
        /**
         * @private
         * @return {?}
         */
        function () {
            if (!this._value)
                this._value = new Date();
            this._groups = [];
            this._selected = [];
            if (~this.type.indexOf('date'))
                this.genDateGroups();
            if (~this.type.indexOf('time'))
                this.genDateTimeGroups();
        };
        /**
         * @private
         * @return {?}
         */
        DatePickerComponent.prototype.genDateGroups = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var year = this._value.getFullYear();
            /** @type {?} */
            var month = this._value.getMonth() + 1;
            /** @type {?} */
            var day = this._value.getDate();
            // year
            /** @type {?} */
            var _selected = 0;
            /** @type {?} */
            var startYear = year - 10;
            /** @type {?} */
            var endYear = year + 10;
            if (this.min)
                startYear = this.min.getFullYear();
            if (this.max)
                endYear = this.max.getFullYear();
            this._groups.push(Array(endYear - startYear + 1)
                .fill(0)
                .map((/**
             * @param {?} _v
             * @param {?} idx
             * @return {?}
             */
            function (_v, idx) {
                /** @type {?} */
                var val = startYear + idx;
                if (val === year)
                    _selected = idx;
                return { label: val + _this._format.yu, value: val };
            })));
            this._selected.push(_selected);
            // month
            /** @type {?} */
            var cy = this._groups[0][_selected].value;
            /** @type {?} */
            var startMonth = 1;
            /** @type {?} */
            var endMonth = 12;
            if (cy === startYear)
                startMonth = this.min.getMonth() + 1;
            if (cy === endYear)
                endMonth = this.max.getMonth() + 1;
            _selected = 0;
            this._groups.push(Array(endMonth - startMonth + 1)
                .fill(0)
                .map((/**
             * @param {?} _v
             * @param {?} idx
             * @return {?}
             */
            function (_v, idx) {
                /** @type {?} */
                var val = startMonth + idx;
                if (val === month)
                    _selected = idx;
                return { label: val + _this._format.Mu, value: val };
            })));
            this._selected.push(_selected);
            // day
            if (this.type !== 'date-ym') {
                /** @type {?} */
                var cm = this._groups[1][_selected].value;
                /** @type {?} */
                var startDay_1 = 1;
                /** @type {?} */
                var endDay = new Date(year, month, 0).getDate();
                if (cy === startYear && cm === startMonth)
                    startDay_1 = this.min.getDate();
                if (cy === endYear && cm === endMonth)
                    endDay = this.max.getDate();
                _selected = 0;
                this._groups.push(Array(endDay - startDay_1 + 1)
                    .fill(0)
                    .map((/**
                 * @param {?} _v
                 * @param {?} idx
                 * @return {?}
                 */
                function (_v, idx) {
                    /** @type {?} */
                    var val = startDay_1 + idx;
                    if (val === day)
                        _selected = idx;
                    return { label: val + _this._format.du, value: val };
                })));
                this._selected.push(_selected);
            }
        };
        /**
         * @private
         * @return {?}
         */
        DatePickerComponent.prototype.genDateTimeGroups = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var hours = this._value.getHours();
            /** @type {?} */
            var minutes = this._value.getMinutes();
            // hours
            /** @type {?} */
            var _selected = 0;
            this._groups.push(Array(24)
                .fill(0)
                .map((/**
             * @param {?} _v
             * @param {?} idx
             * @return {?}
             */
            function (_v, idx) {
                /** @type {?} */
                var val = idx;
                if (val === hours)
                    _selected = idx;
                return { label: val + _this._format.hu, value: val };
            })));
            this._selected.push(_selected);
            // minutes
            _selected = 0;
            this._groups.push(Array(60)
                .fill(0)
                .map((/**
             * @param {?} _v
             * @param {?} idx
             * @return {?}
             */
            function (_v, idx) {
                /** @type {?} */
                var val = idx;
                if (val === minutes)
                    _selected = idx;
                return { label: val + _this._format.mu, value: val };
            })));
            this._selected.push(_selected);
        };
        // 根据selected
        // 根据selected
        /**
         * @private
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        DatePickerComponent.prototype.genValueBySelected = 
        // 根据selected
        /**
         * @private
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        function () {
            if ((/** @type {?} */ (this)).type === 'time') {
                /** @type {?} */
                var now = new Date();
                (/** @type {?} */ (this))._value = new Date(now.getFullYear(), now.getMonth() + 1, now.getDate(), (/** @type {?} */ (this))._groups[0][(/** @type {?} */ (this))._selected[0]].value, (/** @type {?} */ (this))._groups[1][(/** @type {?} */ (this))._selected[1]].value, 0);
                return (/** @type {?} */ (this));
            }
            /** @type {?} */
            var obj = {
                y: (/** @type {?} */ (this))._groups[0][(/** @type {?} */ (this))._selected[0]].value,
                M: (/** @type {?} */ (this))._groups[1][(/** @type {?} */ (this))._selected[1]].value - 1,
                d: (/** @type {?} */ (this)).type !== 'date-ym' ? (/** @type {?} */ (this))._groups[2][(/** @type {?} */ (this))._selected[2]].value : 1,
                h: 0,
                m: 0,
                s: 0,
            };
            if (~(/** @type {?} */ (this)).type.indexOf('time')) {
                obj.h = (/** @type {?} */ (this))._groups[3][(/** @type {?} */ (this))._selected[3]].value;
                obj.m = (/** @type {?} */ (this))._groups[4][(/** @type {?} */ (this))._selected[4]].value;
            }
            (/** @type {?} */ (this))._value = new Date(obj.y, obj.M, obj.d, obj.h, obj.m, obj.s);
            return (/** @type {?} */ (this));
        };
        /**
         * @return {?}
         */
        DatePickerComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this._groups.length = 0;
        };
        /**
         * @private
         * @param {?} date
         * @return {?}
         */
        DatePickerComponent.prototype.getFormatDate = /**
         * @private
         * @param {?} date
         * @return {?}
         */
        function (date) {
            /** @type {?} */
            var f = '';
            if (this._format && this._format.format)
                f = this._format.format;
            else {
                switch (this.type) {
                    case 'date-ym':
                        f = 'yyyy-MM';
                        break;
                    case 'date':
                        f = 'yyyy-MM-dd';
                        break;
                    case 'datetime':
                        f = 'yyyy-MM-dd HH:mm:ss';
                        break;
                    case 'time':
                        f = 'HH:mm';
                        break;
                }
            }
            return this.datePipe.transform(date, f);
        };
        /**
         * @param {?} data
         * @return {?}
         */
        DatePickerComponent.prototype._onCityChange = /**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            this.genValueBySelected();
            /** @type {?} */
            var retVal = new Date(this._value.getTime());
            this.onChange(retVal);
            this.onTouched();
            data.value = retVal;
            data.formatValue = this.getFormatDate(retVal);
            this._pickerInstance._text = data.formatValue;
            this.change.emit(data);
        };
        /**
         * @param {?} res
         * @return {?}
         */
        DatePickerComponent.prototype._onCityGroupChange = /**
         * @param {?} res
         * @return {?}
         */
        function (res) {
            this._selected[res.groupIndex] = res.index;
            if (res.groupIndex !== this._groups.length - 1) {
                this.genValueBySelected().genGroups();
            }
            this.groupChange.emit(res);
        };
        /**
         * @return {?}
         */
        DatePickerComponent.prototype._onCityCancelChange = /**
         * @return {?}
         */
        function () {
            this.cancel.emit();
        };
        /**
         * @return {?}
         */
        DatePickerComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.initFlag = true;
            this.genGroups();
        };
        /**
         * @return {?}
         */
        DatePickerComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
            if (this.initFlag)
                this.genGroups();
        };
        /** 服务于Service，并无实际意义 */
        /**
         * 服务于Service，并无实际意义
         * @return {?}
         */
        DatePickerComponent.prototype._triggerShow = /**
         * 服务于Service，并无实际意义
         * @return {?}
         */
        function () {
            this._pickerInstance._onShow();
        };
        /**
         * @return {?}
         */
        DatePickerComponent.prototype._onShow = /**
         * @return {?}
         */
        function () {
            this.show.emit();
        };
        /**
         * @return {?}
         */
        DatePickerComponent.prototype._onHide = /**
         * @return {?}
         */
        function () {
            this.hide.emit();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        DatePickerComponent.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value)
                this.genGroups();
            this._value = value;
            this._pickerInstance._text = value instanceof Date ? (/** @type {?} */ (this.getFormatDate(value))) : '';
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DatePickerComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DatePickerComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        DatePickerComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.disabled = isDisabled;
        };
        DatePickerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-date-picker',
                        exportAs: 'weuiDatePicker',
                        template: "\n    <weui-picker\n      [placeholder]=\"placeholder\"\n      [groups]=\"_groups\"\n      [defaultSelect]=\"_selected\"\n      [disabled]=\"disabled\"\n      [title]=\"title\"\n      [options]=\"options\"\n      (show)=\"_onShow()\"\n      (hide)=\"_onHide()\"\n      (change)=\"_onCityChange($event)\"\n      (groupChange)=\"_onCityGroupChange($event)\"\n      (cancel)=\"_onCityCancelChange()\"\n    ></weui-picker>\n  ",
                        providers: [
                            common.DatePipe,
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return DatePickerComponent; })),
                                multi: true,
                            },
                        ],
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        DatePickerComponent.ctorParameters = function () { return [
            { type: common.DatePipe }
        ]; };
        DatePickerComponent.propDecorators = {
            _pickerInstance: [{ type: core.ViewChild, args: [PickerComponent, { static: true },] }],
            min: [{ type: core.Input }],
            max: [{ type: core.Input }],
            type: [{ type: core.Input }],
            format: [{ type: core.Input }],
            options: [{ type: core.Input }],
            placeholder: [{ type: core.Input }],
            title: [{ type: core.Input }],
            disabled: [{ type: core.Input }],
            change: [{ type: core.Output }],
            groupChange: [{ type: core.Output }],
            cancel: [{ type: core.Output }],
            show: [{ type: core.Output }],
            hide: [{ type: core.Output }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], DatePickerComponent.prototype, "disabled", void 0);
        return DatePickerComponent;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        DatePickerComponent.prototype.initFlag;
        /**
         * @type {?}
         * @private
         */
        DatePickerComponent.prototype.onChange;
        /**
         * @type {?}
         * @private
         */
        DatePickerComponent.prototype.onTouched;
        /** @type {?} */
        DatePickerComponent.prototype._pickerInstance;
        /** @type {?} */
        DatePickerComponent.prototype._value;
        /** @type {?} */
        DatePickerComponent.prototype._groups;
        /** @type {?} */
        DatePickerComponent.prototype._selected;
        /**
         * 最小时间范围
         * - 当前只限定年月日，暂不包括时间范围
         * @type {?}
         */
        DatePickerComponent.prototype.min;
        /**
         * 最大时间范围
         * - 当前只限定年月日，暂不包括时间范围
         * @type {?}
         */
        DatePickerComponent.prototype.max;
        /**
         * 类型
         * + `date-ym` 年月
         * + `date` 日期
         * + `datetime` 日期&时间（不包括秒）
         * + `time` 时间（不包括秒）
         * @type {?}
         */
        DatePickerComponent.prototype.type;
        /**
         * @type {?}
         * @private
         */
        DatePickerComponent.prototype._format;
        /**
         * 配置项
         * @type {?}
         */
        DatePickerComponent.prototype.options;
        /**
         * 当options.type=='form'时，占位符文本
         * @type {?}
         */
        DatePickerComponent.prototype.placeholder;
        /** @type {?} */
        DatePickerComponent.prototype.title;
        /** @type {?} */
        DatePickerComponent.prototype.disabled;
        /**
         * 确认后回调
         * @type {?}
         */
        DatePickerComponent.prototype.change;
        /**
         * 列变更时回调
         * @type {?}
         */
        DatePickerComponent.prototype.groupChange;
        /**
         * 取消后回调
         * @type {?}
         */
        DatePickerComponent.prototype.cancel;
        /**
         * 显示时回调
         * @type {?}
         */
        DatePickerComponent.prototype.show;
        /**
         * 隐藏后回调
         * @type {?}
         */
        DatePickerComponent.prototype.hide;
        /**
         * @type {?}
         * @private
         */
        DatePickerComponent.prototype.datePipe;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: picker.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 多列选择器Service，可直接通过Class构造选择器
     */
    var PickerService = /** @class */ (function (_super) {
        __extends(PickerService, _super);
        function PickerService(resolver, applicationRef, injector, doc) {
            return _super.call(this, resolver, applicationRef, injector, doc) || this;
        }
        /**
         * 构建一个多列选择器并显示
         *
         * @param data 数据源
         * @param value 默认值（限单列时会根据值自动解析，而对多列使用defaultSelect自行解析）
         * @param defaultSelect 当前默认位置，数组的长度必须等同于 groups 长度
         * @param options 配置项
         * @returns 务必订阅结果才会显示。
         */
        /**
         * 构建一个多列选择器并显示
         *
         * @param {?} data 数据源
         * @param {?=} value 默认值（限单列时会根据值自动解析，而对多列使用defaultSelect自行解析）
         * @param {?=} defaultSelect 当前默认位置，数组的长度必须等同于 groups 长度
         * @param {?=} options 配置项
         * @return {?} 务必订阅结果才会显示。
         */
        PickerService.prototype.show = /**
         * 构建一个多列选择器并显示
         *
         * @param {?} data 数据源
         * @param {?=} value 默认值（限单列时会根据值自动解析，而对多列使用defaultSelect自行解析）
         * @param {?=} defaultSelect 当前默认位置，数组的长度必须等同于 groups 长度
         * @param {?=} options 配置项
         * @return {?} 务必订阅结果才会显示。
         */
        function (data, value, defaultSelect, options) {
            var _this = this;
            /** @type {?} */
            var componentRef = this.build(PickerComponent);
            // 通过Service打开的强制设置为 `default` 以免出现 `input`
            options = __assign(__assign({}, options), { type: 'default' });
            componentRef.instance.options = options;
            if (defaultSelect)
                componentRef.instance.defaultSelect = defaultSelect;
            componentRef.instance.groups = data;
            if (value) {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    componentRef.instance.writeValue(value);
                }), 100);
            }
            componentRef.instance.hide.subscribe((/**
             * @return {?}
             */
            function () {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    _this.destroy(componentRef);
                }), 100);
            }));
            componentRef.instance._onShow();
            return componentRef.instance.change;
        };
        /**
         * 构建一个城市选择器并显示
         *
         * @param data 城市数据，可以参考示例中的数据格式
         * @param [value] 默认值，即城市编号
         * @param options 配置项
         * @returns 务必订阅结果才会显示。
         */
        /**
         * 构建一个城市选择器并显示
         *
         * @param {?} data 城市数据，可以参考示例中的数据格式
         * @param {?=} value
         * @param {?=} dataMap
         * @param {?=} options 配置项
         * @return {?} 务必订阅结果才会显示。
         */
        PickerService.prototype.showCity = /**
         * 构建一个城市选择器并显示
         *
         * @param {?} data 城市数据，可以参考示例中的数据格式
         * @param {?=} value
         * @param {?=} dataMap
         * @param {?=} options 配置项
         * @return {?} 务必订阅结果才会显示。
         */
        function (data, value, dataMap, options) {
            var _this = this;
            /** @type {?} */
            var componentRef = this.build(CityPickerComponent);
            if (dataMap)
                componentRef.instance.dataMap = dataMap;
            // 通过Service打开的强制设置为 `default` 以免出现 `input`
            options = __assign(__assign({}, options), { type: 'default' });
            componentRef.instance.options = options;
            componentRef.instance.data = data;
            if (value) {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    componentRef.instance.writeValue(value);
                }), 100);
            }
            componentRef.instance.hide.subscribe((/**
             * @return {?}
             */
            function () {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    _this.destroy(componentRef);
                }), 100);
            }));
            setTimeout((/**
             * @return {?}
             */
            function () {
                componentRef.instance._triggerShow();
            }), 200);
            return componentRef.instance.change;
        };
        /**
         * 构建一个日期时间选择器并显示
         *
         * @param [type] 类型，date-ym年月，date日期，datetime日期&时间（不包括秒），time时间（不包括秒）
         * @param [format] 日期格式化代码，实际是采用 DatePipe，所有代码内容和它一样
         * @param [value] 默认显示日期
         * @param [min] 最小时间范围
         * @param [max] 最大时间范围
         * @param [options] 配置项
         * @returns 务必订阅结果才会显示。
         */
        /**
         * 构建一个日期时间选择器并显示
         *
         * @param {?=} type
         * @param {?=} format
         * @param {?=} value
         * @param {?=} min
         * @param {?=} max
         * @param {?=} options
         * @return {?} 务必订阅结果才会显示。
         */
        PickerService.prototype.showDateTime = /**
         * 构建一个日期时间选择器并显示
         *
         * @param {?=} type
         * @param {?=} format
         * @param {?=} value
         * @param {?=} min
         * @param {?=} max
         * @param {?=} options
         * @return {?} 务必订阅结果才会显示。
         */
        function (type, format, value, min, max, options) {
            var _this = this;
            /** @type {?} */
            var componentRef = this.build(DatePickerComponent);
            // 通过Service打开的强制设置为 `default` 以免出现 `input`
            options = __assign(__assign({}, options), { type: 'default' });
            componentRef.instance.options = options;
            if (type)
                componentRef.instance.type = type;
            if (format)
                componentRef.instance.format = format;
            if (min)
                componentRef.instance.min = min;
            if (max)
                componentRef.instance.max = max;
            if (value) {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    componentRef.instance.writeValue(value);
                }), 100);
            }
            componentRef.instance.hide.subscribe((/**
             * @return {?}
             */
            function () {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    _this.destroy(componentRef);
                }), 100);
            }));
            setTimeout((/**
             * @return {?}
             */
            function () {
                componentRef.instance.ngOnChanges();
                componentRef.instance._triggerShow();
            }), 200);
            return componentRef.instance.change;
        };
        PickerService.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */
        PickerService.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: core.ApplicationRef },
            { type: core.Injector },
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
        ]; };
        /** @nocollapse */ PickerService.ɵprov = core.ɵɵdefineInjectable({ factory: function PickerService_Factory() { return new PickerService(core.ɵɵinject(core.ComponentFactoryResolver), core.ɵɵinject(core.ApplicationRef), core.ɵɵinject(core.INJECTOR), core.ɵɵinject(common.DOCUMENT)); }, token: PickerService, providedIn: "root" });
        return PickerService;
    }(core$1.BaseService));

    /**
     * @fileoverview added by tsickle
     * Generated from: picker.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var COMPONENTS = [PickerComponent, PickerGroupComponent, DatePickerComponent, CityPickerComponent];
    var PickerModule = /** @class */ (function () {
        function PickerModule() {
        }
        PickerModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: COMPONENTS,
                        exports: COMPONENTS,
                        entryComponents: COMPONENTS,
                    },] }
        ];
        return PickerModule;
    }());

    exports.CityPickerComponent = CityPickerComponent;
    exports.DatePickerComponent = DatePickerComponent;
    exports.FORMAT = FORMAT;
    exports.PickerComponent = PickerComponent;
    exports.PickerConfig = PickerConfig;
    exports.PickerGroupComponent = PickerGroupComponent;
    exports.PickerModule = PickerModule;
    exports.PickerService = PickerService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-picker.umd.js.map
