/**
 * @license ngx-weui(cipchk@qq.com) v9.0.0-rc.1
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("@angular/common"),require("@angular/core"),require("ngx-weui/core")):"function"==typeof define&&define.amd?define("ngx-weui/toast",["exports","@angular/common","@angular/core","ngx-weui/core"],e):e(((t=t||self)["ngx-weui"]=t["ngx-weui"]||{},t["ngx-weui"].toast={}),t.ng.common,t.ng.core,t["ngx-weui"].core)}(this,(function(t,e,n,o){"use strict";
/*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */var i=function(t,e){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(t,e)};function r(t,e){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(t,e)}var c=function(){function t(){this.success={text:"已完成",icon:"weui-icon-success-no-circle",time:2e3},this.loading={text:"加载中…",icon:"weui-loading",time:2e3}}return t.decorators=[{type:n.Injectable,args:[{providedIn:"root"}]}],t.ɵprov=n.ɵɵdefineInjectable({factory:function(){return new t},token:t,providedIn:"root"}),t}();var s=function(){function t(t){this.DEF=t,this.time=2e3,this.hide=new n.EventEmitter,this._showd=!1,this.type="success"}return Object.defineProperty(t.prototype,"type",{set:function(t){Object.assign(this,this.DEF[t])},enumerable:!0,configurable:!0}),t.prototype.onShow=function(){var t=this;return this._showd=!0,this.time>0&&(this.timer=setTimeout((function(){t.onHide()}),this.time)),this},t.prototype.onHide=function(){this._showd=!1,this.hide.emit()},t.prototype.ngOnDestroy=function(){this.timer&&(clearTimeout(this.timer),this.timer=null)},t.decorators=[{type:n.Component,args:[{selector:"weui-toast",exportAs:"weuiToast",template:'<div class="weui-mask_transparent"></div>\n<div class="weui-toast">\n  <i class="{{ icon }} weui-icon_toast"></i>\n  <p class="weui-toast__content">{{ text }}</p>\n</div>\n',host:{"[hidden]":"!_showd"},preserveWhitespaces:!1,changeDetection:n.ChangeDetectionStrategy.OnPush,encapsulation:n.ViewEncapsulation.None}]}],t.ctorParameters=function(){return[{type:c}]},t.propDecorators={type:[{type:n.Input}],text:[{type:n.Input}],icon:[{type:n.Input}],time:[{type:n.Input}],hide:[{type:n.Output}]},function(t,e,n,o){var i,r=arguments.length,c=r<3?e:null===o?o=Object.getOwnPropertyDescriptor(e,n):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)c=Reflect.decorate(t,e,n,o);else for(var s=t.length-1;s>=0;s--)(i=t[s])&&(c=(r<3?i(c):r>3?i(e,n,c):i(e,n))||c);r>3&&c&&Object.defineProperty(e,n,c)}([o.InputNumber(),r("design:type",Number)],t.prototype,"time",void 0),t}();var u=function(t){function o(e,n,o,i){return t.call(this,e,n,o,i)||this}return function(t,e){function n(){this.constructor=t}i(t,e),t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)}(o,t),o.prototype.show=function(t,e,n,o){var i=this.build(s);return o&&(i.instance.type=o),t&&(i.instance.text=t),n&&(i.instance.icon=n),"number"==typeof e&&(i.instance.time=e),i.instance.hide.subscribe((function(){setTimeout((function(){i.destroy()}),300)})),i.instance.onShow()},o.prototype.hide=function(){this.destroy()},o.prototype.success=function(t,e,n){return this.show(t,e,n,"success")},o.prototype.loading=function(t,e,n){return this.show(t,e,n,"loading")},o.decorators=[{type:n.Injectable,args:[{providedIn:"root"}]}],o.ctorParameters=function(){return[{type:n.ComponentFactoryResolver},{type:n.ApplicationRef},{type:n.Injector},{type:void 0,decorators:[{type:n.Inject,args:[e.DOCUMENT]}]}]},o.ɵprov=n.ɵɵdefineInjectable({factory:function(){return new o(n.ɵɵinject(n.ComponentFactoryResolver),n.ɵɵinject(n.ApplicationRef),n.ɵɵinject(n.INJECTOR),n.ɵɵinject(e.DOCUMENT))},token:o,providedIn:"root"}),o}(o.BaseService),a=function(){function t(){}return t.decorators=[{type:n.NgModule,args:[{imports:[e.CommonModule],declarations:[s],exports:[s],entryComponents:[s]}]}],t}();t.ToastComponent=s,t.ToastConfig=c,t.ToastModule=a,t.ToastService=u,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=ngx-weui-toast.umd.min.js.map