/**
 * @license ngx-weui(cipchk@qq.com) v9.0.0-rc.1
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/uploader', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].uploader = {}), global.ng.core, global['ngx-weui'].core, global.ng.common));
}(this, (function (exports, core, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: interface.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: file-like-object.class.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} node
     * @return {?}
     */
    function isElement(node) {
        return !!(node && (node.nodeName || (node.prop && node.attr && node.find)));
    }
    var FileLikeObject = /** @class */ (function () {
        function FileLikeObject(fileOrInput) {
            /** @type {?} */
            var isInput = isElement(fileOrInput);
            /** @type {?} */
            var fakePathOrObject = isInput ? fileOrInput.value : fileOrInput;
            /** @type {?} */
            var postfix = typeof fakePathOrObject === 'string' ? 'FakePath' : 'Object';
            /** @type {?} */
            var method = '_createFrom' + postfix;
            ((/** @type {?} */ (this)))[method](fakePathOrObject);
        }
        /**
         * @param {?} path
         * @return {?}
         */
        FileLikeObject.prototype._createFromFakePath = /**
         * @param {?} path
         * @return {?}
         */
        function (path) {
            this.lastModifiedDate = void 0;
            this.size = void 0;
            this.type = 'like/' + path.slice(path.lastIndexOf('.') + 1).toLowerCase();
            this.name = path.slice(path.lastIndexOf('/') + path.lastIndexOf('\\') + 2);
        };
        /**
         * @param {?} object
         * @return {?}
         */
        FileLikeObject.prototype._createFromObject = /**
         * @param {?} object
         * @return {?}
         */
        function (object) {
            // this.lastModifiedDate = copy(object.lastModifiedDate);
            this.size = object.size;
            this.type = object.type;
            this.name = object.name;
        };
        return FileLikeObject;
    }());
    if (false) {
        /** @type {?} */
        FileLikeObject.prototype.id;
        /** @type {?} */
        FileLikeObject.prototype.lastModifiedDate;
        /** @type {?} */
        FileLikeObject.prototype.size;
        /** @type {?} */
        FileLikeObject.prototype.type;
        /** @type {?} */
        FileLikeObject.prototype.name;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: file-item.class.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 文件对象
     */
    var   /**
     * 文件对象
     */
    FileItem = /** @class */ (function () {
        function FileItem(uploader, file, options) {
            /**
             * 索引
             */
            this.index = 0;
            /**
             * 上传进度
             */
            this.progress = 0;
            /**
             * 准备上传就绪
             */
            this.isReady = false;
            /**
             * 上传中
             */
            this.isUploading = false;
            /**
             * 已上传（不管错误与否都是true）
             */
            this.isUploaded = false;
            /**
             * 上传成功
             */
            this.isSuccess = false;
            /**
             * 用户取消上传
             */
            this.isCancel = false;
            /**
             * 上传失败
             */
            this.isError = false;
            this.uploader = uploader;
            this.setOptions(options);
            this.id = Math.random()
                .toString(36)
                .substring(7);
            this.file = new FileLikeObject(file);
            this._file = file;
        }
        /**
         * @param {?} options
         * @return {?}
         */
        FileItem.prototype.setOptions = /**
         * @param {?} options
         * @return {?}
         */
        function (options) {
            this.options = __assign(__assign({}, this.uploader.options), options);
        };
        /**
         * 上传
         */
        /**
         * 上传
         * @return {?}
         */
        FileItem.prototype.upload = /**
         * 上传
         * @return {?}
         */
        function () {
            try {
                this.uploader.uploadItem(this);
            }
            catch (e) {
                this.uploader._onCompleteItem(this, '', 0, {});
                this.uploader._onErrorItem(this, '', 0, {});
            }
        };
        /**
         * 取消上传
         */
        /**
         * 取消上传
         * @return {?}
         */
        FileItem.prototype.cancel = /**
         * 取消上传
         * @return {?}
         */
        function () {
            this.uploader.cancelItem(this);
        };
        /**
         * 从队列中移除，当文件正在上传中时会先取消
         */
        /**
         * 从队列中移除，当文件正在上传中时会先取消
         * @return {?}
         */
        FileItem.prototype.remove = /**
         * 从队列中移除，当文件正在上传中时会先取消
         * @return {?}
         */
        function () {
            this.uploader.removeFromQueue(this);
        };
        /**
         * @return {?}
         */
        FileItem.prototype._prepareToUploading = /**
         * @return {?}
         */
        function () {
            this.index = this.index || this.uploader._getNextIndex();
            this.isReady = true;
        };
        /**
         * @return {?}
         */
        FileItem.prototype._onBeforeUpload = /**
         * @return {?}
         */
        function () {
            this.isReady = true;
            this.isUploading = true;
            this.isUploaded = false;
            this.isSuccess = false;
            this.isCancel = false;
            this.isError = false;
            this.progress = 0;
            if (this.options.onUploadStart)
                this.options.onUploadStart(this);
        };
        /**
         * @param {?} progress
         * @return {?}
         */
        FileItem.prototype._onProgress = /**
         * @param {?} progress
         * @return {?}
         */
        function (progress) {
            this.progress = progress;
            if (this.options.onUploadProgress)
                this.options.onUploadProgress(this, progress, this.uploader.progress);
        };
        /**
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        FileItem.prototype._onSuccess = /**
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        function (response, status, headers) {
            this.isReady = false;
            this.isUploading = false;
            this.isUploaded = true;
            this.isSuccess = true;
            this.isCancel = false;
            this.isError = false;
            this.progress = 100;
            this.index = 0;
            if (this.options.onUploadSuccess)
                this.options.onUploadSuccess(this, response, status, headers);
        };
        /**
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        FileItem.prototype._onError = /**
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        function (response, status, headers) {
            this.isReady = false;
            this.isUploading = false;
            this.isUploaded = true;
            this.isSuccess = false;
            this.isCancel = false;
            this.isError = true;
            this.progress = 0;
            this.index = 0;
            if (this.options.onUploadError)
                this.options.onUploadError(this, response, status, headers);
        };
        /**
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        FileItem.prototype._onComplete = /**
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        function (response, status, headers) {
            if (this.uploader.options.removeAfterUpload) {
                this.remove();
            }
            if (this.options.onUploadComplete)
                this.options.onUploadComplete(this, response, status, headers);
        };
        /**
         * @return {?}
         */
        FileItem.prototype._onCancel = /**
         * @return {?}
         */
        function () {
            this.isReady = false;
            this.isUploading = false;
            this.isUploaded = false;
            this.isSuccess = false;
            this.isCancel = true;
            this.isError = false;
            this.progress = 0;
            this.index = 0;
            if (this.options.onUploadCancel)
                this.options.onUploadCancel(this);
        };
        return FileItem;
    }());
    if (false) {
        /**
         * 文件ID，每个对象具有唯一ID，与文件名无关
         * @type {?}
         */
        FileItem.prototype.id;
        /**
         * 重建文件结构对象
         * @type {?}
         */
        FileItem.prototype.file;
        /**
         * 原生对象
         * @type {?}
         */
        FileItem.prototype._file;
        /**
         * 索引
         * @type {?}
         */
        FileItem.prototype.index;
        /**
         * 上传进度
         * @type {?}
         */
        FileItem.prototype.progress;
        /**
         * 准备上传就绪
         * @type {?}
         */
        FileItem.prototype.isReady;
        /**
         * 上传中
         * @type {?}
         */
        FileItem.prototype.isUploading;
        /**
         * 已上传（不管错误与否都是true）
         * @type {?}
         */
        FileItem.prototype.isUploaded;
        /**
         * 上传成功
         * @type {?}
         */
        FileItem.prototype.isSuccess;
        /**
         * 用户取消上传
         * @type {?}
         */
        FileItem.prototype.isCancel;
        /**
         * 上传失败
         * @type {?}
         */
        FileItem.prototype.isError;
        /**
         * HTTP请求对象
         * @type {?}
         */
        FileItem.prototype._xhr;
        /**
         * 上传配置信息
         * @type {?}
         */
        FileItem.prototype.options;
        /**
         * @type {?}
         * @protected
         */
        FileItem.prototype.uploader;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: file-type.class.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FileType = /** @class */ (function () {
        function FileType() {
        }
        /**
         * @param {?} file
         * @return {?}
         */
        FileType.getMimeClass = /**
         * @param {?} file
         * @return {?}
         */
        function (file) {
            /** @type {?} */
            var mimeClass = 'application';
            if (this.mime_psd.indexOf(file.type) !== -1) {
                mimeClass = 'image';
            }
            else if (file.type.match('image.*')) {
                mimeClass = 'image';
            }
            else if (file.type.match('video.*')) {
                mimeClass = 'video';
            }
            else if (file.type.match('audio.*')) {
                mimeClass = 'audio';
            }
            else if (file.type === 'application/pdf') {
                mimeClass = 'pdf';
            }
            else if (this.mime_compress.indexOf(file.type) !== -1) {
                mimeClass = 'compress';
            }
            else if (this.mime_doc.indexOf(file.type) !== -1) {
                mimeClass = 'doc';
            }
            else if (this.mime_xsl.indexOf(file.type) !== -1) {
                mimeClass = 'xls';
            }
            else if (this.mime_ppt.indexOf(file.type) !== -1) {
                mimeClass = 'ppt';
            }
            if (mimeClass === 'application') {
                mimeClass = this.fileTypeDetection(file.name);
            }
            return mimeClass;
        };
        /**
         * @param {?} inputFilename
         * @return {?}
         */
        FileType.fileTypeDetection = /**
         * @param {?} inputFilename
         * @return {?}
         */
        function (inputFilename) {
            /** @type {?} */
            var types = {
                jpg: 'image',
                jpeg: 'image',
                tif: 'image',
                psd: 'image',
                bmp: 'image',
                png: 'image',
                nef: 'image',
                tiff: 'image',
                cr2: 'image',
                dwg: 'image',
                cdr: 'image',
                ai: 'image',
                indd: 'image',
                pin: 'image',
                cdp: 'image',
                skp: 'image',
                stp: 'image',
                '3dm': 'image',
                mp3: 'audio',
                wav: 'audio',
                wma: 'audio',
                mod: 'audio',
                m4a: 'audio',
                compress: 'compress',
                rar: 'compress',
                '7z': 'compress',
                lz: 'compress',
                z01: 'compress',
                pdf: 'pdf',
                xls: 'xls',
                xlsx: 'xls',
                ods: 'xls',
                mp4: 'video',
                avi: 'video',
                wmv: 'video',
                mpg: 'video',
                mts: 'video',
                flv: 'video',
                '3gp': 'video',
                vob: 'video',
                m4v: 'video',
                mpeg: 'video',
                m2ts: 'video',
                mov: 'video',
                doc: 'doc',
                docx: 'doc',
                eps: 'doc',
                txt: 'doc',
                odt: 'doc',
                rtf: 'doc',
                ppt: 'ppt',
                pptx: 'ppt',
                pps: 'ppt',
                ppsx: 'ppt',
                odp: 'ppt',
            };
            /** @type {?} */
            var chunks = inputFilename.split('.');
            if (chunks.length < 2) {
                return 'application';
            }
            /** @type {?} */
            var extension = chunks[chunks.length - 1].toLowerCase();
            if (types[extension] === undefined) {
                return 'application';
            }
            else {
                return types[extension];
            }
        };
        /*  MS office  */
        FileType.mime_doc = [
            'application/msword',
            'application/msword',
            'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
            'application/vnd.openxmlformats-officedocument.wordprocessingml.template',
            'application/vnd.ms-word.document.macroEnabled.12',
            'application/vnd.ms-word.template.macroEnabled.12',
        ];
        FileType.mime_xsl = [
            'application/vnd.ms-excel',
            'application/vnd.ms-excel',
            'application/vnd.ms-excel',
            'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
            'application/vnd.openxmlformats-officedocument.spreadsheetml.template',
            'application/vnd.ms-excel.sheet.macroEnabled.12',
            'application/vnd.ms-excel.template.macroEnabled.12',
            'application/vnd.ms-excel.addin.macroEnabled.12',
            'application/vnd.ms-excel.sheet.binary.macroEnabled.12',
        ];
        FileType.mime_ppt = [
            'application/vnd.ms-powerpoint',
            'application/vnd.ms-powerpoint',
            'application/vnd.ms-powerpoint',
            'application/vnd.ms-powerpoint',
            'application/vnd.openxmlformats-officedocument.presentationml.presentation',
            'application/vnd.openxmlformats-officedocument.presentationml.template',
            'application/vnd.openxmlformats-officedocument.presentationml.slideshow',
            'application/vnd.ms-powerpoint.addin.macroEnabled.12',
            'application/vnd.ms-powerpoint.presentation.macroEnabled.12',
            'application/vnd.ms-powerpoint.presentation.macroEnabled.12',
            'application/vnd.ms-powerpoint.slideshow.macroEnabled.12',
        ];
        /* PSD */
        FileType.mime_psd = [
            'image/photoshop',
            'image/x-photoshop',
            'image/psd',
            'application/photoshop',
            'application/psd',
            'zz-application/zz-winassoc-psd',
        ];
        /* Compressed files */
        FileType.mime_compress = [
            'application/x-gtar',
            'application/x-gcompress',
            'application/compress',
            'application/x-tar',
            'application/x-rar-compressed',
            'application/octet-stream',
        ];
        return FileType;
    }());
    if (false) {
        /** @type {?} */
        FileType.mime_doc;
        /** @type {?} */
        FileType.mime_xsl;
        /** @type {?} */
        FileType.mime_ppt;
        /** @type {?} */
        FileType.mime_psd;
        /** @type {?} */
        FileType.mime_compress;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: uploader.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UploaderConfig = /** @class */ (function () {
        function UploaderConfig() {
            /**
             * 发送凭据，默认：`true`
             */
            this.withCredentials = true;
            /**
             * 是否自动上传，默认：`false`
             * 设置为 true 后，不需要手动调用 `upload`，有文件选择即开始上传。
             */
            this.auto = false;
            /**
             * 允许最多上传数量，-1 表示不受限，默认：`-1`
             */
            this.limit = -1;
            /**
             * 限定文件大小（单位：字节），-1 表示不受限，默认：`-1`
             */
            this.size = -1;
        }
        UploaderConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ UploaderConfig.ɵprov = core.ɵɵdefineInjectable({ factory: function UploaderConfig_Factory() { return new UploaderConfig(); }, token: UploaderConfig, providedIn: "root" });
        return UploaderConfig;
    }());
    if (false) {
        /**
         * 服务端网址
         * @type {?}
         */
        UploaderConfig.prototype.url;
        /**
         * HTTP请求方式
         * @type {?}
         */
        UploaderConfig.prototype.method;
        /**
         * 设置文件上传域的name
         * @type {?}
         */
        UploaderConfig.prototype.alias;
        /**
         * 发送凭据，默认：`true`
         * @type {?}
         */
        UploaderConfig.prototype.withCredentials;
        /**
         * headers 信息
         * @type {?}
         */
        UploaderConfig.prototype.headers;
        /**
         * 是否自动上传，默认：`false`
         * 设置为 true 后，不需要手动调用 `upload`，有文件选择即开始上传。
         * @type {?}
         */
        UploaderConfig.prototype.auto;
        /**
         * 限定文件mime类型，例如：[ '' ]
         * @type {?}
         */
        UploaderConfig.prototype.mimes;
        /**
         * 限定文件类型，例如：[ 'jpg', 'png' ]
         * @type {?}
         */
        UploaderConfig.prototype.types;
        /**
         * 允许最多上传数量，-1 表示不受限，默认：`-1`
         * @type {?}
         */
        UploaderConfig.prototype.limit;
        /**
         * 限定文件大小（单位：字节），-1 表示不受限，默认：`-1`
         * @type {?}
         */
        UploaderConfig.prototype.size;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: uploader.options.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 组件Header对象接口
     * @record
     */
    function UploaderHeaders() { }
    if (false) {
        /** @type {?} */
        UploaderHeaders.prototype.name;
        /** @type {?} */
        UploaderHeaders.prototype.value;
    }
    /**
     * 组件配置项对象接口
     * @record
     */
    function UploaderOptions() { }
    if (false) {
        /**
         * 服务端网址
         * @type {?|undefined}
         */
        UploaderOptions.prototype.url;
        /**
         * HTTP请求方式，默认：`POST`
         * @type {?|undefined}
         */
        UploaderOptions.prototype.method;
        /**
         * 设置文件上传域的name
         * @type {?|undefined}
         */
        UploaderOptions.prototype.alias;
        /**
         * 是否发送凭据，默认：`true`
         * @type {?|undefined}
         */
        UploaderOptions.prototype.withCredentials;
        /**
         * headers 信息
         * @type {?|undefined}
         */
        UploaderOptions.prototype.headers;
        /**
         * HTTP提交其他参数
         * @type {?|undefined}
         */
        UploaderOptions.prototype.params;
        /**
         * 过滤器
         * @type {?|undefined}
         */
        UploaderOptions.prototype.filters;
        /**
         * 是否自动上传，默认：`false`
         * 设置为 true 后，不需要手动调用 `upload`，有文件选择即开始上传。
         * @type {?|undefined}
         */
        UploaderOptions.prototype.auto;
        /**
         * 限定文件mime类型，例如：[ '' ]
         * @type {?|undefined}
         */
        UploaderOptions.prototype.mimes;
        /**
         * 限定文件类型，例如：[ 'jpg', 'png' ]
         * @type {?|undefined}
         */
        UploaderOptions.prototype.types;
        /**
         * 允许最多上传数量，-1 表示不受限，默认：`-1`
         * @type {?|undefined}
         */
        UploaderOptions.prototype.limit;
        /**
         * 限定文件大小（单位：字节），-1 表示不受限，默认：`-1`
         * @type {?|undefined}
         */
        UploaderOptions.prototype.size;
        /**
         * 是否自动移除上传成功文件，默认：`false`
         * @type {?|undefined}
         */
        UploaderOptions.prototype.removeAfterUpload;
        /**
         * 禁止使用multipart/form-data，默认：`false`
         * @type {?|undefined}
         */
        UploaderOptions.prototype.disableMultipart;
        /**
         * 当文件被加入队列以后触发
         * @type {?|undefined}
         */
        UploaderOptions.prototype.onFileQueued;
        /**
         * 当文件被移除队列后触发
         *
         * \@param file File对象，如果是clear则file为空
         * @type {?|undefined}
         */
        UploaderOptions.prototype.onFileDequeued;
        /**
         * 当开始上传流程时触发
         * @type {?|undefined}
         */
        UploaderOptions.prototype.onStart;
        /**
         * 当开始上传流程取消时触发
         * @type {?|undefined}
         */
        UploaderOptions.prototype.onCancel;
        /**
         * 当所有文件上传结束时触发
         * @type {?|undefined}
         */
        UploaderOptions.prototype.onFinished;
        /**
         * 某个文件开始上传前触发，一个文件只会触发一次
         * @type {?|undefined}
         */
        UploaderOptions.prototype.onUploadStart;
        /**
         * 上传过程中触发，携带总的上传进度，以及当前文件的上传进度
         * \@param file File对象
         * \@param percentage 当前文件上传进度
         * \@param totaoPercentage 总上传进度
         * @type {?|undefined}
         */
        UploaderOptions.prototype.onUploadProgress;
        /**
         * 当文件上传成功时触发
         * \@param file File对象
         * \@param response 服务端返回的数据
         * \@param status 状态码
         * \@param headers Headers
         * @type {?|undefined}
         */
        UploaderOptions.prototype.onUploadSuccess;
        /**
         * 当文件上传出错时触发
         * \@param file File对象
         * \@param response 服务端返回的数据
         * \@param status 状态码
         * \@param headers Headers
         * @type {?|undefined}
         */
        UploaderOptions.prototype.onUploadError;
        /**
         * 不管成功或者失败，文件上传完成时触发
         * \@param file File对象
         * \@param response 服务端返回的数据
         * \@param status 状态码
         * \@param headers Headers
         * @type {?|undefined}
         */
        UploaderOptions.prototype.onUploadComplete;
        /**
         * 取消某文件时触发
         *
         * \@param file File对象
         * @type {?|undefined}
         */
        UploaderOptions.prototype.onUploadCancel;
        /**
         * 当filters不通过时触发
         * \@param file 文件对象
         * \@param filter 过滤器
         * \@param options 选项
         * @type {?|undefined}
         */
        UploaderOptions.prototype.onError;
        /**
         * 内置的上传组件是基于HTML5
         * 如有特殊需求可以自定义上传接口（Observable<any> 中的 any 指的是事件当中的response）
         * 不管成功与否都会触发 onUploadComplete & onUploadSuccess
         * @param {?} item
         * @return {?}
         */
        UploaderOptions.prototype.uploadTransport = function (item) { };
        /**
         * 自定义上传接口，当用户中止时回调
         * @param {?} item
         * @return {?}
         */
        UploaderOptions.prototype.abortTransport = function (item) { };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: uploader.class.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 内置HTML5上传组件
     */
    var Uploader = /** @class */ (function () {
        /**
         * Creates an instance of Uploader.
         */
        function Uploader(options, globalConfig) {
            this.globalConfig = globalConfig;
            this._queue = [];
            this._progress = 0;
            this._isUploading = false;
            this._nextIndex = 0;
            this.setOptions(options);
        }
        Object.defineProperty(Uploader.prototype, "options", {
            /**
             * 获取当前上传组件配置项
             */
            get: /**
             * 获取当前上传组件配置项
             * @return {?}
             */
            function () {
                return this._options;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Uploader.prototype, "queue", {
            /**
             * 获取队列中所有文件对象
             */
            get: /**
             * 获取队列中所有文件对象
             * @return {?}
             */
            function () {
                return this._queue;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Uploader.prototype, "progress", {
            /**
             * 获取当前总进度
             */
            get: /**
             * 获取当前总进度
             * @return {?}
             */
            function () {
                return this._progress;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Uploader.prototype, "isUploading", {
            /**
             * 是否上传中
             */
            get: /**
             * 是否上传中
             * @return {?}
             */
            function () {
                return this._isUploading;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Uploader.prototype, "notUploadedCount", {
            /**
             * 获取未上传数量
             */
            get: /**
             * 获取未上传数量
             * @return {?}
             */
            function () {
                return this.getNotUploadedItems().length;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Uploader.prototype, "uploadedCount", {
            /**
             * 获取已上传数量
             */
            get: /**
             * 获取已上传数量
             * @return {?}
             */
            function () {
                return this._queue.filter((/**
                 * @param {?} item
                 * @return {?}
                 */
                function (item) { return item.isUploaded; })).length;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        Uploader.prototype._getNextIndex = /**
         * @return {?}
         */
        function () {
            return ++this._nextIndex;
        };
        /**
         * 重置选项
         *
         * @param includeOldQueue 是否包括已存在队列中的文件
         */
        /**
         * 重置选项
         *
         * @param {?} options
         * @param {?=} includeOldQueue 是否包括已存在队列中的文件
         * @return {?}
         */
        Uploader.prototype.setOptions = /**
         * 重置选项
         *
         * @param {?} options
         * @param {?=} includeOldQueue 是否包括已存在队列中的文件
         * @return {?}
         */
        function (options, includeOldQueue) {
            if (includeOldQueue === void 0) { includeOldQueue = true; }
            this._options = (/** @type {?} */ (__assign(__assign(__assign({ filters: [], disableMultipart: false, method: 'POST', alias: 'file', withCredentials: true, auto: false, limit: -1, size: -1, removeAfterUpload: false }, this.globalConfig), this._options), options)));
            // 数量
            if (this._options.limit !== -1)
                (/** @type {?} */ (this._options.filters)).unshift({
                    name: 'queueLimit',
                    fn: this._queueLimitFilter,
                });
            // 大小
            if (this._options.size !== -1)
                (/** @type {?} */ (this._options.filters)).unshift({
                    name: 'fileSize',
                    fn: this._fileSizeFilter,
                });
            // 类型
            if (this._options.types)
                (/** @type {?} */ (this._options.filters)).unshift({
                    name: 'fileType',
                    fn: this._fileTypeFilter,
                });
            // mime类型
            if (this._options.mimes)
                (/** @type {?} */ (this._options.filters)).unshift({
                    name: 'mimeType',
                    fn: this._mimeTypeFilter,
                });
            // 对已经存在的队列重置所有配置信息
            if (includeOldQueue) {
                // tslint:disable-next-line: prefer-for-of
                for (var i = 0; i < this._queue.length; i++) {
                    this._queue[i].setOptions(this._options);
                }
            }
        };
        /**
         * @private
         * @return {?}
         */
        Uploader.prototype._queueLimitFilter = /**
         * @private
         * @return {?}
         */
        function () {
            return this._options.limit === undefined || this._queue.length < this._options.limit;
        };
        /**
         * @private
         * @param {?=} item
         * @param {?=} _options
         * @return {?}
         */
        Uploader.prototype._fileSizeFilter = /**
         * @private
         * @param {?=} item
         * @param {?=} _options
         * @return {?}
         */
        function (item, _options) {
            return !(this._options.size && (/** @type {?} */ (item)).size > this._options.size);
        };
        /**
         * @private
         * @param {?=} item
         * @param {?=} _options
         * @return {?}
         */
        Uploader.prototype._mimeTypeFilter = /**
         * @private
         * @param {?=} item
         * @param {?=} _options
         * @return {?}
         */
        function (item, _options) {
            return !(this._options.mimes && this._options.mimes.indexOf((/** @type {?} */ (item)).type) === -1);
        };
        /**
         * @private
         * @param {?=} item
         * @param {?=} _options
         * @return {?}
         */
        Uploader.prototype._fileTypeFilter = /**
         * @private
         * @param {?=} item
         * @param {?=} _options
         * @return {?}
         */
        function (item, _options) {
            return !(this._options.types && this._options.types.indexOf(FileType.getMimeClass((/** @type {?} */ (item)))) === -1);
        };
        /**
         * @private
         * @param {?} file
         * @param {?} filters
         * @param {?} options
         * @return {?}
         */
        Uploader.prototype._isValidFile = /**
         * @private
         * @param {?} file
         * @param {?} filters
         * @param {?} options
         * @return {?}
         */
        function (file, filters, options) {
            var _this = this;
            this._failFilterIndex = -1;
            return !filters.length
                ? true
                : filters.every((/**
                 * @param {?} filter
                 * @return {?}
                 */
                function (filter) {
                    _this._failFilterIndex++;
                    return filter.fn.call(_this, file, options);
                }));
        };
        /** 过滤器，如果未指定采用内置 */
        /**
         * 过滤器，如果未指定采用内置
         * @private
         * @param {?} filters
         * @return {?}
         */
        Uploader.prototype._getFilters = /**
         * 过滤器，如果未指定采用内置
         * @private
         * @param {?} filters
         * @return {?}
         */
        function (filters) {
            if (!filters)
                return (/** @type {?} */ (this._options.filters));
            if (Array.isArray(filters))
                return filters;
            if (typeof filters === 'string') {
                /** @type {?} */
                var names_1 = (/** @type {?} */ (filters.match(/[^\s,]+/g)));
                return (/** @type {?} */ (this._options.filters)).filter((/**
                 * @param {?} filter
                 * @return {?}
                 */
                function (filter) { return names_1.indexOf(filter.name) !== -1; }));
            }
            return (/** @type {?} */ (this._options.filters));
        };
        /**
         * @private
         * @param {?} value
         * @return {?}
         */
        Uploader.prototype._getIndexOfItem = /**
         * @private
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return typeof value === 'number' ? value : this._queue.indexOf(value);
        };
        /** 获取未上传过列表 */
        /**
         * 获取未上传过列表
         * @private
         * @return {?}
         */
        Uploader.prototype.getNotUploadedItems = /**
         * 获取未上传过列表
         * @private
         * @return {?}
         */
        function () {
            return this._queue.filter((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return !item.isUploaded; }));
        };
        Object.defineProperty(Uploader.prototype, "getReadyItems", {
            /** 获取待上传文件 */
            get: /**
             * 获取待上传文件
             * @return {?}
             */
            function () {
                return this._queue
                    .filter((/**
                 * @param {?} item
                 * @return {?}
                 */
                function (item) { return item.isReady && !item.isUploading; }))
                    .sort((/**
                 * @param {?} item1
                 * @param {?} item2
                 * @return {?}
                 */
                function (item1, item2) { return item1.index - item2.index; }));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * 将文件放入队列中
         *
         * @param files 文件列表
         * @param options 强制重新指定新 `options` 内容
         * @param filters 强制重新指定新 `filters` 内容
         */
        /**
         * 将文件放入队列中
         *
         * @param {?} files 文件列表
         * @param {?=} options 强制重新指定新 `options` 内容
         * @param {?=} filters 强制重新指定新 `filters` 内容
         * @return {?}
         */
        Uploader.prototype.addToQueue = /**
         * 将文件放入队列中
         *
         * @param {?} files 文件列表
         * @param {?=} options 强制重新指定新 `options` 内容
         * @param {?=} filters 强制重新指定新 `filters` 内容
         * @return {?}
         */
        function (files, options, filters) {
            var e_1, _a;
            var _this = this;
            /** @type {?} */
            var list = [];
            try {
                for (var files_1 = __values(files), files_1_1 = files_1.next(); !files_1_1.done; files_1_1 = files_1.next()) {
                    var file = files_1_1.value;
                    list.push(file);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (files_1_1 && !files_1_1.done && (_a = files_1.return)) _a.call(files_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            /** @type {?} */
            var arrayOfFilters = this._getFilters((/** @type {?} */ (filters)));
            /** @type {?} */
            var count = this._queue.length;
            /** @type {?} */
            var addedFileItems = [];
            if (!options) {
                options = this._options;
            }
            list.forEach((/**
             * @param {?} some
             * @param {?} index
             * @return {?}
             */
            function (some, index) {
                /** @type {?} */
                var temp = new FileLikeObject(some);
                if (_this._isValidFile(temp, arrayOfFilters, (/** @type {?} */ (options)))) {
                    /** @type {?} */
                    var fileItem = new FileItem(_this, some, (/** @type {?} */ (options)));
                    fileItem.index = index;
                    addedFileItems.push(fileItem);
                    _this._queue.push(fileItem);
                    if (_this._options.onFileQueued)
                        _this._options.onFileQueued(fileItem);
                }
                else {
                    /** @type {?} */
                    var filter = arrayOfFilters[_this._failFilterIndex];
                    if (_this._options.onError)
                        _this._options.onError(temp, filter, (/** @type {?} */ (options)));
                }
            }));
            if (this.queue.length !== count) {
                this._progress = this._getTotalProgress();
            }
            if ((/** @type {?} */ (this.options)).auto) {
                this.uploadAll();
            }
        };
        /**
         * 从队列中移除一个文件
         *
         * @param value FileItem对象或下标
         */
        /**
         * 从队列中移除一个文件
         *
         * @param {?} value FileItem对象或下标
         * @return {?}
         */
        Uploader.prototype.removeFromQueue = /**
         * 从队列中移除一个文件
         *
         * @param {?} value FileItem对象或下标
         * @return {?}
         */
        function (value) {
            /** @type {?} */
            var index = this._getIndexOfItem(value);
            /** @type {?} */
            var item = this._queue[index];
            if (item.isUploading) {
                item.cancel();
            }
            this._queue.splice(index, 1);
            this._progress = this._getTotalProgress();
            if (this._options.onFileDequeued)
                this._options.onFileDequeued(item);
        };
        /**
         * 清空队列
         */
        /**
         * 清空队列
         * @return {?}
         */
        Uploader.prototype.clearQueue = /**
         * 清空队列
         * @return {?}
         */
        function () {
            while (this._queue.length) {
                this._queue[0].remove();
            }
            this._progress = 0;
            if (this._options.onFileDequeued)
                this._options.onFileDequeued();
        };
        /**
         * 上传某个文件
         */
        /**
         * 上传某个文件
         * @param {?} value
         * @return {?}
         */
        Uploader.prototype.uploadItem = /**
         * 上传某个文件
         * @param {?} value
         * @return {?}
         */
        function (value) {
            /** @type {?} */
            var index = this._getIndexOfItem(value);
            /** @type {?} */
            var item = this._queue[index];
            item._prepareToUploading();
            if (this._isUploading) {
                return;
            }
            this._isUploading = true;
            this._xhrTransport(item);
        };
        /**
         * 取消某个文件
         */
        /**
         * 取消某个文件
         * @param {?} value
         * @return {?}
         */
        Uploader.prototype.cancelItem = /**
         * 取消某个文件
         * @param {?} value
         * @return {?}
         */
        function (value) {
            /** @type {?} */
            var index = this._getIndexOfItem(value);
            /** @type {?} */
            var item = this._queue[index];
            if (item && item.isUploading) {
                if (item.options.abortTransport) {
                    this._onCancelItem(item);
                    this._onCompleteItem(item, (/** @type {?} */ (null)), (/** @type {?} */ (null)), (/** @type {?} */ (null)));
                    item.options.abortTransport(item);
                }
                else {
                    if (item._xhr)
                        item._xhr.abort();
                }
            }
        };
        /**
         * 上传队列中所有未上传的文件
         */
        /**
         * 上传队列中所有未上传的文件
         * @return {?}
         */
        Uploader.prototype.uploadAll = /**
         * 上传队列中所有未上传的文件
         * @return {?}
         */
        function () {
            /** @type {?} */
            var items = this.getNotUploadedItems().filter((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return !item.isUploading; }));
            if (!items.length) {
                return;
            }
            items.map((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item._prepareToUploading(); }));
            if (this._options.onStart)
                this._options.onStart(items[0]);
            items[0].upload();
        };
        /**
         * 取消所有上传中文件
         */
        /**
         * 取消所有上传中文件
         * @return {?}
         */
        Uploader.prototype.cancelAll = /**
         * 取消所有上传中文件
         * @return {?}
         */
        function () {
            /** @type {?} */
            var items = this.getNotUploadedItems();
            items.map((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item.cancel(); }));
            if (this._options.onCancel)
                this._options.onCancel();
        };
        /**
         * @return {?}
         */
        Uploader.prototype._destroy = /**
         * @return {?}
         */
        function () {
            return void 0;
        };
        /**
         * @private
         * @param {?} item
         * @return {?}
         */
        Uploader.prototype._xhrTransport = /**
         * @private
         * @param {?} item
         * @return {?}
         */
        function (item) {
            var e_2, _a;
            var _this = this;
            item._onBeforeUpload();
            // 自实现
            if (item.options.uploadTransport) {
                item.options.uploadTransport.apply(this, [item]).subscribe((/**
                 * @param {?} response
                 * @return {?}
                 */
                function (response) {
                    _this._onSuccessItem(item, response, 0, (/** @type {?} */ (null)));
                    _this._onCompleteItem(item, response, 0, (/** @type {?} */ (null)));
                }));
                return this;
            }
            /** @type {?} */
            var xhr = (item._xhr = new XMLHttpRequest());
            /** @type {?} */
            var sendable;
            if (typeof item._file.size !== 'number') {
                throw new TypeError('The file specified is no longer valid');
            }
            if (!this._options.disableMultipart) {
                sendable = new FormData();
                Object.keys(this._options.params || {}).forEach((/**
                 * @param {?} key
                 * @return {?}
                 */
                function (key) { return sendable.append(key, (/** @type {?} */ (_this._options.params))[key]); }));
                sendable.append(item.options.alias, item._file, item.file.name);
            }
            else {
                sendable = item._file;
            }
            xhr.upload.onprogress = (/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                /** @type {?} */
                var progress = Math.round(event.lengthComputable ? (event.loaded * 100) / event.total : 0);
                _this._onProgressItem(item, progress);
            });
            xhr.onload = (/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var headers = _this._parseHeaders(xhr.getAllResponseHeaders());
                /** @type {?} */
                var response = _this._transformResponse(xhr.response, headers);
                /** @type {?} */
                var gist = _this._isSuccessCode(xhr.status) ? 'Success' : 'Error';
                /** @type {?} */
                var method = "_on" + gist + "Item";
                ((/** @type {?} */ (_this)))[method](item, response, xhr.status, headers);
                _this._onCompleteItem(item, response, xhr.status, headers);
            });
            xhr.onerror = (/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var headers = _this._parseHeaders(xhr.getAllResponseHeaders());
                /** @type {?} */
                var response = _this._transformResponse(xhr.response, headers);
                _this._onErrorItem(item, response, xhr.status, headers);
                _this._onCompleteItem(item, response, xhr.status, headers);
            });
            xhr.onabort = (/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var headers = _this._parseHeaders(xhr.getAllResponseHeaders());
                /** @type {?} */
                var response = _this._transformResponse(xhr.response, headers);
                _this._onCancelItem(item);
                _this._onCompleteItem(item, response, xhr.status, headers);
            });
            xhr.open((/** @type {?} */ (item.options.method)), (/** @type {?} */ (item.options.url)), true);
            xhr.withCredentials = (/** @type {?} */ (item.options.withCredentials));
            if (item.options.headers && item.options.headers.length > 0) {
                try {
                    for (var _b = __values(item.options.headers), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var header = _c.value;
                        xhr.setRequestHeader(header.name, header.value);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            xhr.send(sendable);
            return this;
        };
        /**
         * @private
         * @param {?=} value
         * @return {?}
         */
        Uploader.prototype._getTotalProgress = /**
         * @private
         * @param {?=} value
         * @return {?}
         */
        function (value) {
            if (value === void 0) { value = 0; }
            if (this._options.removeAfterUpload) {
                return value;
            }
            /** @type {?} */
            var notUploaded = this.getNotUploadedItems().length;
            /** @type {?} */
            var uploaded = notUploaded ? this._queue.length - notUploaded : this._queue.length;
            /** @type {?} */
            var ratio = 100 / this._queue.length;
            /** @type {?} */
            var current = (value * ratio) / 100;
            return Math.round(uploaded * ratio + current);
        };
        /**
         * @private
         * @param {?} headers
         * @return {?}
         */
        Uploader.prototype._parseHeaders = /**
         * @private
         * @param {?} headers
         * @return {?}
         */
        function (headers) {
            /** @type {?} */
            var parsed = {};
            /** @type {?} */
            var key;
            /** @type {?} */
            var val;
            /** @type {?} */
            var i;
            if (!headers) {
                return parsed;
            }
            headers.split('\n').map((/**
             * @param {?} line
             * @return {?}
             */
            function (line) {
                i = line.indexOf(':');
                key = line.slice(0, i).trim().toLowerCase();
                val = line.slice(i + 1).trim();
                if (key) {
                    parsed[key] = parsed[key] ? parsed[key] + ", " + val : val;
                }
            }));
            return parsed;
        };
        /**
         * @private
         * @param {?} response
         * @param {?} _headers
         * @return {?}
         */
        Uploader.prototype._transformResponse = /**
         * @private
         * @param {?} response
         * @param {?} _headers
         * @return {?}
         */
        function (response, _headers) {
            return response;
        };
        /**
         * @private
         * @param {?} status
         * @return {?}
         */
        Uploader.prototype._isSuccessCode = /**
         * @private
         * @param {?} status
         * @return {?}
         */
        function (status) {
            return (status >= 200 && status < 300) || status === 304;
        };
        /**
         * @private
         * @param {?} item
         * @param {?} progress
         * @return {?}
         */
        Uploader.prototype._onProgressItem = /**
         * @private
         * @param {?} item
         * @param {?} progress
         * @return {?}
         */
        function (item, progress) {
            /** @type {?} */
            var total = this._getTotalProgress(progress);
            this._progress = total;
            item._onProgress(progress);
        };
        /**
         * @param {?} item
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        Uploader.prototype._onErrorItem = /**
         * @param {?} item
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        function (item, response, status, headers) {
            item._onError(response, status, headers);
        };
        /**
         * @private
         * @param {?} item
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        Uploader.prototype._onSuccessItem = /**
         * @private
         * @param {?} item
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        function (item, response, status, headers) {
            item._onSuccess(response, status, headers);
        };
        /**
         * @private
         * @param {?} item
         * @return {?}
         */
        Uploader.prototype._onCancelItem = /**
         * @private
         * @param {?} item
         * @return {?}
         */
        function (item) {
            item._onCancel();
        };
        /**
         * @param {?} item
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        Uploader.prototype._onCompleteItem = /**
         * @param {?} item
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        function (item, response, status, headers) {
            item._onComplete(response, status, headers);
            /** @type {?} */
            var nextItem = this.getReadyItems[0];
            this._isUploading = false;
            if (nextItem) {
                nextItem.upload();
                return;
            }
            this._progress = this._getTotalProgress();
            if (this._options.onFinished)
                this._options.onFinished();
        };
        /** @nocollapse */
        Uploader.ctorParameters = function () { return [
            { type: undefined },
            { type: UploaderConfig, decorators: [{ type: core.Inject, args: [UploaderConfig,] }, { type: core.Optional }] }
        ]; };
        return Uploader;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        Uploader.prototype._options;
        /**
         * @type {?}
         * @private
         */
        Uploader.prototype._queue;
        /**
         * @type {?}
         * @private
         */
        Uploader.prototype._progress;
        /**
         * @type {?}
         * @private
         */
        Uploader.prototype._isUploading;
        /**
         * @type {?}
         * @private
         */
        Uploader.prototype._nextIndex;
        /**
         * @type {?}
         * @private
         */
        Uploader.prototype._failFilterIndex;
        /**
         * @type {?}
         * @private
         */
        Uploader.prototype.globalConfig;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: uploader.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UploaderFileDirective = /** @class */ (function () {
        function UploaderFileDirective() {
        }
        /**
         * @param {?} e
         * @return {?}
         */
        UploaderFileDirective.prototype._onChange = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            /** @type {?} */
            var hie = (/** @type {?} */ (e.target));
            this.uploader.addToQueue((/** @type {?} */ (((/** @type {?} */ ((/** @type {?} */ (hie.files))))))), this.uploader.options);
            if (!!((/** @type {?} */ (hie.attributes))).multiple) {
                hie.value = '';
            }
        };
        UploaderFileDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[weui-uploader-file]',
                        exportAs: 'weuiUploaderFile',
                        host: {
                            '(change)': '_onChange($event)',
                        },
                    },] }
        ];
        UploaderFileDirective.propDecorators = {
            uploader: [{ type: core.Input, args: ['weui-uploader-file',] }]
        };
        return UploaderFileDirective;
    }());
    if (false) {
        /**
         * Uploader对象，必填项
         * @type {?}
         */
        UploaderFileDirective.prototype.uploader;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: file-thumb.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 创建缩略图
     */
    var FileThumbDirective = /** @class */ (function () {
        function FileThumbDirective(el) {
            this.el = el;
        }
        /**
         * @private
         * @return {?}
         */
        FileThumbDirective.prototype.render = /**
         * @private
         * @return {?}
         */
        function () {
            if (!this.file) {
                return;
            }
            /** @type {?} */
            var url = core$1.genImageUrl(this.file);
            if (!url) {
                return;
            }
            this.el.nativeElement.style.backgroundImage = "url(" + url + ")";
        };
        /**
         * @return {?}
         */
        FileThumbDirective.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
            this.render();
        };
        FileThumbDirective.decorators = [
            { type: core.Directive, args: [{ selector: '[weui-thumb]' },] }
        ];
        /** @nocollapse */
        FileThumbDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        FileThumbDirective.propDecorators = {
            file: [{ type: core.Input, args: ['weui-thumb',] }]
        };
        return FileThumbDirective;
    }());
    if (false) {
        /**
         * 文件对象，必填项
         * @type {?}
         */
        FileThumbDirective.prototype.file;
        /**
         * @type {?}
         * @private
         */
        FileThumbDirective.prototype.el;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: uploader.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UploaderModule = /** @class */ (function () {
        function UploaderModule() {
        }
        UploaderModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [UploaderFileDirective, FileThumbDirective],
                        exports: [UploaderFileDirective, FileThumbDirective],
                    },] }
        ];
        return UploaderModule;
    }());

    exports.FileItem = FileItem;
    exports.FileLikeObject = FileLikeObject;
    exports.FileThumbDirective = FileThumbDirective;
    exports.FileType = FileType;
    exports.Uploader = Uploader;
    exports.UploaderConfig = UploaderConfig;
    exports.UploaderFileDirective = UploaderFileDirective;
    exports.UploaderModule = UploaderModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-uploader.umd.js.map
